package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class CaseConsumptionPlanExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CaseConsumptionPlanExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andCaseConsumptionPlanIdIsNull() {
            addCriterion("case_consumption_plan_id is null");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdIsNotNull() {
            addCriterion("case_consumption_plan_id is not null");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdEqualTo(String value) {
            addCriterion("case_consumption_plan_id =", value, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdNotEqualTo(String value) {
            addCriterion("case_consumption_plan_id <>", value, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdGreaterThan(String value) {
            addCriterion("case_consumption_plan_id >", value, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdGreaterThanOrEqualTo(String value) {
            addCriterion("case_consumption_plan_id >=", value, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdLessThan(String value) {
            addCriterion("case_consumption_plan_id <", value, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdLessThanOrEqualTo(String value) {
            addCriterion("case_consumption_plan_id <=", value, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdLike(String value) {
            addCriterion("case_consumption_plan_id like", value, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdNotLike(String value) {
            addCriterion("case_consumption_plan_id not like", value, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdIn(List<String> values) {
            addCriterion("case_consumption_plan_id in", values, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdNotIn(List<String> values) {
            addCriterion("case_consumption_plan_id not in", values, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdBetween(String value1, String value2) {
            addCriterion("case_consumption_plan_id between", value1, value2, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseConsumptionPlanIdNotBetween(String value1, String value2) {
            addCriterion("case_consumption_plan_id not between", value1, value2, "caseConsumptionPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseIdIsNull() {
            addCriterion("case_id is null");
            return (Criteria) this;
        }

        public Criteria andCaseIdIsNotNull() {
            addCriterion("case_id is not null");
            return (Criteria) this;
        }

        public Criteria andCaseIdEqualTo(String value) {
            addCriterion("case_id =", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdNotEqualTo(String value) {
            addCriterion("case_id <>", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdGreaterThan(String value) {
            addCriterion("case_id >", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdGreaterThanOrEqualTo(String value) {
            addCriterion("case_id >=", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdLessThan(String value) {
            addCriterion("case_id <", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdLessThanOrEqualTo(String value) {
            addCriterion("case_id <=", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdLike(String value) {
            addCriterion("case_id like", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdNotLike(String value) {
            addCriterion("case_id not like", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdIn(List<String> values) {
            addCriterion("case_id in", values, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdNotIn(List<String> values) {
            addCriterion("case_id not in", values, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdBetween(String value1, String value2) {
            addCriterion("case_id between", value1, value2, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdNotBetween(String value1, String value2) {
            addCriterion("case_id not between", value1, value2, "caseId");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentIsNull() {
            addCriterion("monthly_investment is null");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentIsNotNull() {
            addCriterion("monthly_investment is not null");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentEqualTo(BigDecimal value) {
            addCriterion("monthly_investment =", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentNotEqualTo(BigDecimal value) {
            addCriterion("monthly_investment <>", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentGreaterThan(BigDecimal value) {
            addCriterion("monthly_investment >", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("monthly_investment >=", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentLessThan(BigDecimal value) {
            addCriterion("monthly_investment <", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentLessThanOrEqualTo(BigDecimal value) {
            addCriterion("monthly_investment <=", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentIn(List<BigDecimal> values) {
            addCriterion("monthly_investment in", values, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentNotIn(List<BigDecimal> values) {
            addCriterion("monthly_investment not in", values, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("monthly_investment between", value1, value2, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("monthly_investment not between", value1, value2, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsIsNull() {
            addCriterion("available_assets is null");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsIsNotNull() {
            addCriterion("available_assets is not null");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsEqualTo(BigDecimal value) {
            addCriterion("available_assets =", value, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsNotEqualTo(BigDecimal value) {
            addCriterion("available_assets <>", value, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsGreaterThan(BigDecimal value) {
            addCriterion("available_assets >", value, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("available_assets >=", value, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsLessThan(BigDecimal value) {
            addCriterion("available_assets <", value, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsLessThanOrEqualTo(BigDecimal value) {
            addCriterion("available_assets <=", value, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsIn(List<BigDecimal> values) {
            addCriterion("available_assets in", values, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsNotIn(List<BigDecimal> values) {
            addCriterion("available_assets not in", values, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("available_assets between", value1, value2, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andAvailableAssetsNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("available_assets not between", value1, value2, "availableAssets");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearIsNull() {
            addCriterion("shop_house_year is null");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearIsNotNull() {
            addCriterion("shop_house_year is not null");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearEqualTo(Integer value) {
            addCriterion("shop_house_year =", value, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearNotEqualTo(Integer value) {
            addCriterion("shop_house_year <>", value, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearGreaterThan(Integer value) {
            addCriterion("shop_house_year >", value, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearGreaterThanOrEqualTo(Integer value) {
            addCriterion("shop_house_year >=", value, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearLessThan(Integer value) {
            addCriterion("shop_house_year <", value, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearLessThanOrEqualTo(Integer value) {
            addCriterion("shop_house_year <=", value, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearIn(List<Integer> values) {
            addCriterion("shop_house_year in", values, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearNotIn(List<Integer> values) {
            addCriterion("shop_house_year not in", values, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearBetween(Integer value1, Integer value2) {
            addCriterion("shop_house_year between", value1, value2, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andShopHouseYearNotBetween(Integer value1, Integer value2) {
            addCriterion("shop_house_year not between", value1, value2, "shopHouseYear");
            return (Criteria) this;
        }

        public Criteria andHouseAreaIsNull() {
            addCriterion("house_area is null");
            return (Criteria) this;
        }

        public Criteria andHouseAreaIsNotNull() {
            addCriterion("house_area is not null");
            return (Criteria) this;
        }

        public Criteria andHouseAreaEqualTo(BigDecimal value) {
            addCriterion("house_area =", value, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaNotEqualTo(BigDecimal value) {
            addCriterion("house_area <>", value, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaGreaterThan(BigDecimal value) {
            addCriterion("house_area >", value, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_area >=", value, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaLessThan(BigDecimal value) {
            addCriterion("house_area <", value, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_area <=", value, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaIn(List<BigDecimal> values) {
            addCriterion("house_area in", values, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaNotIn(List<BigDecimal> values) {
            addCriterion("house_area not in", values, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_area between", value1, value2, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHouseAreaNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_area not between", value1, value2, "houseArea");
            return (Criteria) this;
        }

        public Criteria andHousePriceIsNull() {
            addCriterion("house_price is null");
            return (Criteria) this;
        }

        public Criteria andHousePriceIsNotNull() {
            addCriterion("house_price is not null");
            return (Criteria) this;
        }

        public Criteria andHousePriceEqualTo(BigDecimal value) {
            addCriterion("house_price =", value, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceNotEqualTo(BigDecimal value) {
            addCriterion("house_price <>", value, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceGreaterThan(BigDecimal value) {
            addCriterion("house_price >", value, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_price >=", value, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceLessThan(BigDecimal value) {
            addCriterion("house_price <", value, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_price <=", value, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceIn(List<BigDecimal> values) {
            addCriterion("house_price in", values, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceNotIn(List<BigDecimal> values) {
            addCriterion("house_price not in", values, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_price between", value1, value2, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHousePriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_price not between", value1, value2, "housePrice");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyIsNull() {
            addCriterion("house_all_money is null");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyIsNotNull() {
            addCriterion("house_all_money is not null");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyEqualTo(BigDecimal value) {
            addCriterion("house_all_money =", value, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyNotEqualTo(BigDecimal value) {
            addCriterion("house_all_money <>", value, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyGreaterThan(BigDecimal value) {
            addCriterion("house_all_money >", value, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_all_money >=", value, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyLessThan(BigDecimal value) {
            addCriterion("house_all_money <", value, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_all_money <=", value, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyIn(List<BigDecimal> values) {
            addCriterion("house_all_money in", values, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyNotIn(List<BigDecimal> values) {
            addCriterion("house_all_money not in", values, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_all_money between", value1, value2, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseAllMoneyNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_all_money not between", value1, value2, "houseAllMoney");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentIsNull() {
            addCriterion("house_down_payment_percent is null");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentIsNotNull() {
            addCriterion("house_down_payment_percent is not null");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentEqualTo(BigDecimal value) {
            addCriterion("house_down_payment_percent =", value, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentNotEqualTo(BigDecimal value) {
            addCriterion("house_down_payment_percent <>", value, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentGreaterThan(BigDecimal value) {
            addCriterion("house_down_payment_percent >", value, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_down_payment_percent >=", value, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentLessThan(BigDecimal value) {
            addCriterion("house_down_payment_percent <", value, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_down_payment_percent <=", value, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentIn(List<BigDecimal> values) {
            addCriterion("house_down_payment_percent in", values, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentNotIn(List<BigDecimal> values) {
            addCriterion("house_down_payment_percent not in", values, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_down_payment_percent between", value1, value2, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentPercentNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_down_payment_percent not between", value1, value2, "houseDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearIsNull() {
            addCriterion("house_loan_year is null");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearIsNotNull() {
            addCriterion("house_loan_year is not null");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearEqualTo(Integer value) {
            addCriterion("house_loan_year =", value, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearNotEqualTo(Integer value) {
            addCriterion("house_loan_year <>", value, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearGreaterThan(Integer value) {
            addCriterion("house_loan_year >", value, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearGreaterThanOrEqualTo(Integer value) {
            addCriterion("house_loan_year >=", value, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearLessThan(Integer value) {
            addCriterion("house_loan_year <", value, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearLessThanOrEqualTo(Integer value) {
            addCriterion("house_loan_year <=", value, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearIn(List<Integer> values) {
            addCriterion("house_loan_year in", values, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearNotIn(List<Integer> values) {
            addCriterion("house_loan_year not in", values, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearBetween(Integer value1, Integer value2) {
            addCriterion("house_loan_year between", value1, value2, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanYearNotBetween(Integer value1, Integer value2) {
            addCriterion("house_loan_year not between", value1, value2, "houseLoanYear");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateIsNull() {
            addCriterion("house_loan_rate is null");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateIsNotNull() {
            addCriterion("house_loan_rate is not null");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateEqualTo(BigDecimal value) {
            addCriterion("house_loan_rate =", value, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateNotEqualTo(BigDecimal value) {
            addCriterion("house_loan_rate <>", value, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateGreaterThan(BigDecimal value) {
            addCriterion("house_loan_rate >", value, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_loan_rate >=", value, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateLessThan(BigDecimal value) {
            addCriterion("house_loan_rate <", value, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_loan_rate <=", value, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateIn(List<BigDecimal> values) {
            addCriterion("house_loan_rate in", values, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateNotIn(List<BigDecimal> values) {
            addCriterion("house_loan_rate not in", values, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_loan_rate between", value1, value2, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseLoanRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_loan_rate not between", value1, value2, "houseLoanRate");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentIsNull() {
            addCriterion("house_down_payment is null");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentIsNotNull() {
            addCriterion("house_down_payment is not null");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentEqualTo(BigDecimal value) {
            addCriterion("house_down_payment =", value, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentNotEqualTo(BigDecimal value) {
            addCriterion("house_down_payment <>", value, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentGreaterThan(BigDecimal value) {
            addCriterion("house_down_payment >", value, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_down_payment >=", value, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentLessThan(BigDecimal value) {
            addCriterion("house_down_payment <", value, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_down_payment <=", value, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentIn(List<BigDecimal> values) {
            addCriterion("house_down_payment in", values, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentNotIn(List<BigDecimal> values) {
            addCriterion("house_down_payment not in", values, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_down_payment between", value1, value2, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseDownPaymentNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_down_payment not between", value1, value2, "houseDownPayment");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountIsNull() {
            addCriterion("house_total_amount is null");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountIsNotNull() {
            addCriterion("house_total_amount is not null");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountEqualTo(BigDecimal value) {
            addCriterion("house_total_amount =", value, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountNotEqualTo(BigDecimal value) {
            addCriterion("house_total_amount <>", value, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountGreaterThan(BigDecimal value) {
            addCriterion("house_total_amount >", value, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_total_amount >=", value, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountLessThan(BigDecimal value) {
            addCriterion("house_total_amount <", value, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_total_amount <=", value, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountIn(List<BigDecimal> values) {
            addCriterion("house_total_amount in", values, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountNotIn(List<BigDecimal> values) {
            addCriterion("house_total_amount not in", values, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_total_amount between", value1, value2, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andHouseTotalAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_total_amount not between", value1, value2, "houseTotalAmount");
            return (Criteria) this;
        }

        public Criteria andDisposableInputIsNull() {
            addCriterion("disposable_input is null");
            return (Criteria) this;
        }

        public Criteria andDisposableInputIsNotNull() {
            addCriterion("disposable_input is not null");
            return (Criteria) this;
        }

        public Criteria andDisposableInputEqualTo(BigDecimal value) {
            addCriterion("disposable_input =", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputNotEqualTo(BigDecimal value) {
            addCriterion("disposable_input <>", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputGreaterThan(BigDecimal value) {
            addCriterion("disposable_input >", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("disposable_input >=", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputLessThan(BigDecimal value) {
            addCriterion("disposable_input <", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputLessThanOrEqualTo(BigDecimal value) {
            addCriterion("disposable_input <=", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputIn(List<BigDecimal> values) {
            addCriterion("disposable_input in", values, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputNotIn(List<BigDecimal> values) {
            addCriterion("disposable_input not in", values, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("disposable_input between", value1, value2, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("disposable_input not between", value1, value2, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountIsNull() {
            addCriterion("house_monthly_amount is null");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountIsNotNull() {
            addCriterion("house_monthly_amount is not null");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountEqualTo(BigDecimal value) {
            addCriterion("house_monthly_amount =", value, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountNotEqualTo(BigDecimal value) {
            addCriterion("house_monthly_amount <>", value, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountGreaterThan(BigDecimal value) {
            addCriterion("house_monthly_amount >", value, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_monthly_amount >=", value, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountLessThan(BigDecimal value) {
            addCriterion("house_monthly_amount <", value, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_monthly_amount <=", value, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountIn(List<BigDecimal> values) {
            addCriterion("house_monthly_amount in", values, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountNotIn(List<BigDecimal> values) {
            addCriterion("house_monthly_amount not in", values, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_monthly_amount between", value1, value2, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andHouseMonthlyAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_monthly_amount not between", value1, value2, "houseMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andShopCarYearIsNull() {
            addCriterion("shop_car_year is null");
            return (Criteria) this;
        }

        public Criteria andShopCarYearIsNotNull() {
            addCriterion("shop_car_year is not null");
            return (Criteria) this;
        }

        public Criteria andShopCarYearEqualTo(Integer value) {
            addCriterion("shop_car_year =", value, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearNotEqualTo(Integer value) {
            addCriterion("shop_car_year <>", value, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearGreaterThan(Integer value) {
            addCriterion("shop_car_year >", value, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearGreaterThanOrEqualTo(Integer value) {
            addCriterion("shop_car_year >=", value, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearLessThan(Integer value) {
            addCriterion("shop_car_year <", value, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearLessThanOrEqualTo(Integer value) {
            addCriterion("shop_car_year <=", value, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearIn(List<Integer> values) {
            addCriterion("shop_car_year in", values, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearNotIn(List<Integer> values) {
            addCriterion("shop_car_year not in", values, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearBetween(Integer value1, Integer value2) {
            addCriterion("shop_car_year between", value1, value2, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andShopCarYearNotBetween(Integer value1, Integer value2) {
            addCriterion("shop_car_year not between", value1, value2, "shopCarYear");
            return (Criteria) this;
        }

        public Criteria andCarTypeIsNull() {
            addCriterion("car_type is null");
            return (Criteria) this;
        }

        public Criteria andCarTypeIsNotNull() {
            addCriterion("car_type is not null");
            return (Criteria) this;
        }

        public Criteria andCarTypeEqualTo(String value) {
            addCriterion("car_type =", value, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeNotEqualTo(String value) {
            addCriterion("car_type <>", value, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeGreaterThan(String value) {
            addCriterion("car_type >", value, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeGreaterThanOrEqualTo(String value) {
            addCriterion("car_type >=", value, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeLessThan(String value) {
            addCriterion("car_type <", value, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeLessThanOrEqualTo(String value) {
            addCriterion("car_type <=", value, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeLike(String value) {
            addCriterion("car_type like", value, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeNotLike(String value) {
            addCriterion("car_type not like", value, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeIn(List<String> values) {
            addCriterion("car_type in", values, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeNotIn(List<String> values) {
            addCriterion("car_type not in", values, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeBetween(String value1, String value2) {
            addCriterion("car_type between", value1, value2, "carType");
            return (Criteria) this;
        }

        public Criteria andCarTypeNotBetween(String value1, String value2) {
            addCriterion("car_type not between", value1, value2, "carType");
            return (Criteria) this;
        }

        public Criteria andCarPriceIsNull() {
            addCriterion("car_price is null");
            return (Criteria) this;
        }

        public Criteria andCarPriceIsNotNull() {
            addCriterion("car_price is not null");
            return (Criteria) this;
        }

        public Criteria andCarPriceEqualTo(BigDecimal value) {
            addCriterion("car_price =", value, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceNotEqualTo(BigDecimal value) {
            addCriterion("car_price <>", value, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceGreaterThan(BigDecimal value) {
            addCriterion("car_price >", value, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("car_price >=", value, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceLessThan(BigDecimal value) {
            addCriterion("car_price <", value, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("car_price <=", value, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceIn(List<BigDecimal> values) {
            addCriterion("car_price in", values, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceNotIn(List<BigDecimal> values) {
            addCriterion("car_price not in", values, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_price between", value1, value2, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_price not between", value1, value2, "carPrice");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentIsNull() {
            addCriterion("car_down_payment_percent is null");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentIsNotNull() {
            addCriterion("car_down_payment_percent is not null");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentEqualTo(BigDecimal value) {
            addCriterion("car_down_payment_percent =", value, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentNotEqualTo(BigDecimal value) {
            addCriterion("car_down_payment_percent <>", value, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentGreaterThan(BigDecimal value) {
            addCriterion("car_down_payment_percent >", value, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("car_down_payment_percent >=", value, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentLessThan(BigDecimal value) {
            addCriterion("car_down_payment_percent <", value, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentLessThanOrEqualTo(BigDecimal value) {
            addCriterion("car_down_payment_percent <=", value, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentIn(List<BigDecimal> values) {
            addCriterion("car_down_payment_percent in", values, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentNotIn(List<BigDecimal> values) {
            addCriterion("car_down_payment_percent not in", values, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_down_payment_percent between", value1, value2, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentPercentNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_down_payment_percent not between", value1, value2, "carDownPaymentPercent");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearIsNull() {
            addCriterion("car_loan_year is null");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearIsNotNull() {
            addCriterion("car_loan_year is not null");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearEqualTo(Integer value) {
            addCriterion("car_loan_year =", value, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearNotEqualTo(Integer value) {
            addCriterion("car_loan_year <>", value, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearGreaterThan(Integer value) {
            addCriterion("car_loan_year >", value, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearGreaterThanOrEqualTo(Integer value) {
            addCriterion("car_loan_year >=", value, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearLessThan(Integer value) {
            addCriterion("car_loan_year <", value, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearLessThanOrEqualTo(Integer value) {
            addCriterion("car_loan_year <=", value, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearIn(List<Integer> values) {
            addCriterion("car_loan_year in", values, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearNotIn(List<Integer> values) {
            addCriterion("car_loan_year not in", values, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearBetween(Integer value1, Integer value2) {
            addCriterion("car_loan_year between", value1, value2, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanYearNotBetween(Integer value1, Integer value2) {
            addCriterion("car_loan_year not between", value1, value2, "carLoanYear");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateIsNull() {
            addCriterion("car_loan_rate is null");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateIsNotNull() {
            addCriterion("car_loan_rate is not null");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateEqualTo(BigDecimal value) {
            addCriterion("car_loan_rate =", value, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateNotEqualTo(BigDecimal value) {
            addCriterion("car_loan_rate <>", value, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateGreaterThan(BigDecimal value) {
            addCriterion("car_loan_rate >", value, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("car_loan_rate >=", value, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateLessThan(BigDecimal value) {
            addCriterion("car_loan_rate <", value, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("car_loan_rate <=", value, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateIn(List<BigDecimal> values) {
            addCriterion("car_loan_rate in", values, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateNotIn(List<BigDecimal> values) {
            addCriterion("car_loan_rate not in", values, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_loan_rate between", value1, value2, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andCarLoanRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_loan_rate not between", value1, value2, "carLoanRate");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxIsNull() {
            addCriterion("purchase_tax is null");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxIsNotNull() {
            addCriterion("purchase_tax is not null");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxEqualTo(BigDecimal value) {
            addCriterion("purchase_tax =", value, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxNotEqualTo(BigDecimal value) {
            addCriterion("purchase_tax <>", value, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxGreaterThan(BigDecimal value) {
            addCriterion("purchase_tax >", value, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("purchase_tax >=", value, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxLessThan(BigDecimal value) {
            addCriterion("purchase_tax <", value, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxLessThanOrEqualTo(BigDecimal value) {
            addCriterion("purchase_tax <=", value, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxIn(List<BigDecimal> values) {
            addCriterion("purchase_tax in", values, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxNotIn(List<BigDecimal> values) {
            addCriterion("purchase_tax not in", values, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("purchase_tax between", value1, value2, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andPurchaseTaxNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("purchase_tax not between", value1, value2, "purchaseTax");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeIsNull() {
            addCriterion("car_reg_fee is null");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeIsNotNull() {
            addCriterion("car_reg_fee is not null");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeEqualTo(BigDecimal value) {
            addCriterion("car_reg_fee =", value, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeNotEqualTo(BigDecimal value) {
            addCriterion("car_reg_fee <>", value, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeGreaterThan(BigDecimal value) {
            addCriterion("car_reg_fee >", value, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("car_reg_fee >=", value, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeLessThan(BigDecimal value) {
            addCriterion("car_reg_fee <", value, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("car_reg_fee <=", value, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeIn(List<BigDecimal> values) {
            addCriterion("car_reg_fee in", values, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeNotIn(List<BigDecimal> values) {
            addCriterion("car_reg_fee not in", values, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_reg_fee between", value1, value2, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andCarRegFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_reg_fee not between", value1, value2, "carRegFee");
            return (Criteria) this;
        }

        public Criteria andDisplacementIsNull() {
            addCriterion("displacement is null");
            return (Criteria) this;
        }

        public Criteria andDisplacementIsNotNull() {
            addCriterion("displacement is not null");
            return (Criteria) this;
        }

        public Criteria andDisplacementEqualTo(Integer value) {
            addCriterion("displacement =", value, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementNotEqualTo(Integer value) {
            addCriterion("displacement <>", value, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementGreaterThan(Integer value) {
            addCriterion("displacement >", value, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementGreaterThanOrEqualTo(Integer value) {
            addCriterion("displacement >=", value, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementLessThan(Integer value) {
            addCriterion("displacement <", value, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementLessThanOrEqualTo(Integer value) {
            addCriterion("displacement <=", value, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementIn(List<Integer> values) {
            addCriterion("displacement in", values, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementNotIn(List<Integer> values) {
            addCriterion("displacement not in", values, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementBetween(Integer value1, Integer value2) {
            addCriterion("displacement between", value1, value2, "displacement");
            return (Criteria) this;
        }

        public Criteria andDisplacementNotBetween(Integer value1, Integer value2) {
            addCriterion("displacement not between", value1, value2, "displacement");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxIsNull() {
            addCriterion("vehicle_and_vessel_tax is null");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxIsNotNull() {
            addCriterion("vehicle_and_vessel_tax is not null");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxEqualTo(BigDecimal value) {
            addCriterion("vehicle_and_vessel_tax =", value, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxNotEqualTo(BigDecimal value) {
            addCriterion("vehicle_and_vessel_tax <>", value, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxGreaterThan(BigDecimal value) {
            addCriterion("vehicle_and_vessel_tax >", value, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("vehicle_and_vessel_tax >=", value, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxLessThan(BigDecimal value) {
            addCriterion("vehicle_and_vessel_tax <", value, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxLessThanOrEqualTo(BigDecimal value) {
            addCriterion("vehicle_and_vessel_tax <=", value, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxIn(List<BigDecimal> values) {
            addCriterion("vehicle_and_vessel_tax in", values, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxNotIn(List<BigDecimal> values) {
            addCriterion("vehicle_and_vessel_tax not in", values, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("vehicle_and_vessel_tax between", value1, value2, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andVehicleAndVesselTaxNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("vehicle_and_vessel_tax not between", value1, value2, "vehicleAndVesselTax");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryIsNull() {
            addCriterion("motor_vehicle_compulsory is null");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryIsNotNull() {
            addCriterion("motor_vehicle_compulsory is not null");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryEqualTo(BigDecimal value) {
            addCriterion("motor_vehicle_compulsory =", value, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryNotEqualTo(BigDecimal value) {
            addCriterion("motor_vehicle_compulsory <>", value, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryGreaterThan(BigDecimal value) {
            addCriterion("motor_vehicle_compulsory >", value, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("motor_vehicle_compulsory >=", value, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryLessThan(BigDecimal value) {
            addCriterion("motor_vehicle_compulsory <", value, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryLessThanOrEqualTo(BigDecimal value) {
            addCriterion("motor_vehicle_compulsory <=", value, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryIn(List<BigDecimal> values) {
            addCriterion("motor_vehicle_compulsory in", values, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryNotIn(List<BigDecimal> values) {
            addCriterion("motor_vehicle_compulsory not in", values, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("motor_vehicle_compulsory between", value1, value2, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCompulsoryNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("motor_vehicle_compulsory not between", value1, value2, "motorVehicleCompulsory");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialIsNull() {
            addCriterion("motor_vehicle_commercial is null");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialIsNotNull() {
            addCriterion("motor_vehicle_commercial is not null");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialEqualTo(BigDecimal value) {
            addCriterion("motor_vehicle_commercial =", value, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialNotEqualTo(BigDecimal value) {
            addCriterion("motor_vehicle_commercial <>", value, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialGreaterThan(BigDecimal value) {
            addCriterion("motor_vehicle_commercial >", value, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("motor_vehicle_commercial >=", value, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialLessThan(BigDecimal value) {
            addCriterion("motor_vehicle_commercial <", value, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialLessThanOrEqualTo(BigDecimal value) {
            addCriterion("motor_vehicle_commercial <=", value, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialIn(List<BigDecimal> values) {
            addCriterion("motor_vehicle_commercial in", values, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialNotIn(List<BigDecimal> values) {
            addCriterion("motor_vehicle_commercial not in", values, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("motor_vehicle_commercial between", value1, value2, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andMotorVehicleCommercialNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("motor_vehicle_commercial not between", value1, value2, "motorVehicleCommercial");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentIsNull() {
            addCriterion("car_down_payment is null");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentIsNotNull() {
            addCriterion("car_down_payment is not null");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentEqualTo(BigDecimal value) {
            addCriterion("car_down_payment =", value, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentNotEqualTo(BigDecimal value) {
            addCriterion("car_down_payment <>", value, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentGreaterThan(BigDecimal value) {
            addCriterion("car_down_payment >", value, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("car_down_payment >=", value, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentLessThan(BigDecimal value) {
            addCriterion("car_down_payment <", value, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentLessThanOrEqualTo(BigDecimal value) {
            addCriterion("car_down_payment <=", value, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentIn(List<BigDecimal> values) {
            addCriterion("car_down_payment in", values, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentNotIn(List<BigDecimal> values) {
            addCriterion("car_down_payment not in", values, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_down_payment between", value1, value2, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarDownPaymentNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_down_payment not between", value1, value2, "carDownPayment");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountIsNull() {
            addCriterion("car_total_amount is null");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountIsNotNull() {
            addCriterion("car_total_amount is not null");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountEqualTo(BigDecimal value) {
            addCriterion("car_total_amount =", value, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountNotEqualTo(BigDecimal value) {
            addCriterion("car_total_amount <>", value, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountGreaterThan(BigDecimal value) {
            addCriterion("car_total_amount >", value, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("car_total_amount >=", value, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountLessThan(BigDecimal value) {
            addCriterion("car_total_amount <", value, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("car_total_amount <=", value, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountIn(List<BigDecimal> values) {
            addCriterion("car_total_amount in", values, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountNotIn(List<BigDecimal> values) {
            addCriterion("car_total_amount not in", values, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_total_amount between", value1, value2, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarTotalAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_total_amount not between", value1, value2, "carTotalAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountIsNull() {
            addCriterion("car_monthly_amount is null");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountIsNotNull() {
            addCriterion("car_monthly_amount is not null");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountEqualTo(BigDecimal value) {
            addCriterion("car_monthly_amount =", value, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountNotEqualTo(BigDecimal value) {
            addCriterion("car_monthly_amount <>", value, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountGreaterThan(BigDecimal value) {
            addCriterion("car_monthly_amount >", value, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("car_monthly_amount >=", value, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountLessThan(BigDecimal value) {
            addCriterion("car_monthly_amount <", value, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("car_monthly_amount <=", value, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountIn(List<BigDecimal> values) {
            addCriterion("car_monthly_amount in", values, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountNotIn(List<BigDecimal> values) {
            addCriterion("car_monthly_amount not in", values, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_monthly_amount between", value1, value2, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andCarMonthlyAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("car_monthly_amount not between", value1, value2, "carMonthlyAmount");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentIsNull() {
            addCriterion("return_on_investment is null");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentIsNotNull() {
            addCriterion("return_on_investment is not null");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentEqualTo(BigDecimal value) {
            addCriterion("return_on_investment =", value, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentNotEqualTo(BigDecimal value) {
            addCriterion("return_on_investment <>", value, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentGreaterThan(BigDecimal value) {
            addCriterion("return_on_investment >", value, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("return_on_investment >=", value, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentLessThan(BigDecimal value) {
            addCriterion("return_on_investment <", value, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentLessThanOrEqualTo(BigDecimal value) {
            addCriterion("return_on_investment <=", value, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentIn(List<BigDecimal> values) {
            addCriterion("return_on_investment in", values, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentNotIn(List<BigDecimal> values) {
            addCriterion("return_on_investment not in", values, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("return_on_investment between", value1, value2, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("return_on_investment not between", value1, value2, "returnOnInvestment");
            return (Criteria) this;
        }

        public Criteria andLumpSumIsNull() {
            addCriterion("lump_sum is null");
            return (Criteria) this;
        }

        public Criteria andLumpSumIsNotNull() {
            addCriterion("lump_sum is not null");
            return (Criteria) this;
        }

        public Criteria andLumpSumEqualTo(BigDecimal value) {
            addCriterion("lump_sum =", value, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumNotEqualTo(BigDecimal value) {
            addCriterion("lump_sum <>", value, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumGreaterThan(BigDecimal value) {
            addCriterion("lump_sum >", value, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("lump_sum >=", value, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumLessThan(BigDecimal value) {
            addCriterion("lump_sum <", value, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumLessThanOrEqualTo(BigDecimal value) {
            addCriterion("lump_sum <=", value, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumIn(List<BigDecimal> values) {
            addCriterion("lump_sum in", values, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumNotIn(List<BigDecimal> values) {
            addCriterion("lump_sum not in", values, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lump_sum between", value1, value2, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andLumpSumNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lump_sum not between", value1, value2, "lumpSum");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountIsNull() {
            addCriterion("month_regular_invest_amount is null");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountIsNotNull() {
            addCriterion("month_regular_invest_amount is not null");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountEqualTo(BigDecimal value) {
            addCriterion("month_regular_invest_amount =", value, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountNotEqualTo(BigDecimal value) {
            addCriterion("month_regular_invest_amount <>", value, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountGreaterThan(BigDecimal value) {
            addCriterion("month_regular_invest_amount >", value, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("month_regular_invest_amount >=", value, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountLessThan(BigDecimal value) {
            addCriterion("month_regular_invest_amount <", value, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("month_regular_invest_amount <=", value, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountIn(List<BigDecimal> values) {
            addCriterion("month_regular_invest_amount in", values, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountNotIn(List<BigDecimal> values) {
            addCriterion("month_regular_invest_amount not in", values, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("month_regular_invest_amount between", value1, value2, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andMonthRegularInvestAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("month_regular_invest_amount not between", value1, value2, "monthRegularInvestAmount");
            return (Criteria) this;
        }

        public Criteria andRegularYearIsNull() {
            addCriterion("regular_year is null");
            return (Criteria) this;
        }

        public Criteria andRegularYearIsNotNull() {
            addCriterion("regular_year is not null");
            return (Criteria) this;
        }

        public Criteria andRegularYearEqualTo(Integer value) {
            addCriterion("regular_year =", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearNotEqualTo(Integer value) {
            addCriterion("regular_year <>", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearGreaterThan(Integer value) {
            addCriterion("regular_year >", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearGreaterThanOrEqualTo(Integer value) {
            addCriterion("regular_year >=", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearLessThan(Integer value) {
            addCriterion("regular_year <", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearLessThanOrEqualTo(Integer value) {
            addCriterion("regular_year <=", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearIn(List<Integer> values) {
            addCriterion("regular_year in", values, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearNotIn(List<Integer> values) {
            addCriterion("regular_year not in", values, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearBetween(Integer value1, Integer value2) {
            addCriterion("regular_year between", value1, value2, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearNotBetween(Integer value1, Integer value2) {
            addCriterion("regular_year not between", value1, value2, "regularYear");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIsNull() {
            addCriterion("analysis_teacher_score is null");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIsNotNull() {
            addCriterion("analysis_teacher_score is not null");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score =", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score <>", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreGreaterThan(BigDecimal value) {
            addCriterion("analysis_teacher_score >", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score >=", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreLessThan(BigDecimal value) {
            addCriterion("analysis_teacher_score <", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score <=", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIn(List<BigDecimal> values) {
            addCriterion("analysis_teacher_score in", values, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotIn(List<BigDecimal> values) {
            addCriterion("analysis_teacher_score not in", values, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("analysis_teacher_score between", value1, value2, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("analysis_teacher_score not between", value1, value2, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreIsNull() {
            addCriterion("case_teacher_score is null");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreIsNotNull() {
            addCriterion("case_teacher_score is not null");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreEqualTo(BigDecimal value) {
            addCriterion("case_teacher_score =", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreNotEqualTo(BigDecimal value) {
            addCriterion("case_teacher_score <>", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreGreaterThan(BigDecimal value) {
            addCriterion("case_teacher_score >", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("case_teacher_score >=", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreLessThan(BigDecimal value) {
            addCriterion("case_teacher_score <", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("case_teacher_score <=", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreIn(List<BigDecimal> values) {
            addCriterion("case_teacher_score in", values, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreNotIn(List<BigDecimal> values) {
            addCriterion("case_teacher_score not in", values, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("case_teacher_score between", value1, value2, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("case_teacher_score not between", value1, value2, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNull() {
            addCriterion("is_answer is null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNotNull() {
            addCriterion("is_answer is not null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerEqualTo(String value) {
            addCriterion("is_answer =", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotEqualTo(String value) {
            addCriterion("is_answer <>", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThan(String value) {
            addCriterion("is_answer >", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThanOrEqualTo(String value) {
            addCriterion("is_answer >=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThan(String value) {
            addCriterion("is_answer <", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThanOrEqualTo(String value) {
            addCriterion("is_answer <=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLike(String value) {
            addCriterion("is_answer like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotLike(String value) {
            addCriterion("is_answer not like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIn(List<String> values) {
            addCriterion("is_answer in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotIn(List<String> values) {
            addCriterion("is_answer not in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerBetween(String value1, String value2) {
            addCriterion("is_answer between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotBetween(String value1, String value2) {
            addCriterion("is_answer not between", value1, value2, "isAnswer");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}