package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
/**
 * 投资规划-P2P产品信息表
 *
 * @author xcj
 * case_investment_plan_p2p_productinfo
 */
public class CaseInvestmentPlanP2PProductInfo {
    @ApiModelProperty("P2P产品信息ID")
    private String p2pProductinfoId;

    @ApiModelProperty("产品选择ID")
    private String productSelectId;

    @ApiModelProperty("所属层级（基础层/保值层）")
    private String level;

    @ApiModelProperty("P2P产品ID")
    private String p2pProductId;

    @ApiModelProperty("投资金额")
    private BigDecimal investmentAmount;

    @ApiModelProperty("添加时间")
    private Date addTime;

    public String getP2pProductinfoId() {
        return p2pProductinfoId;
    }

    public void setP2pProductinfoId(String p2pProductinfoId) {
        this.p2pProductinfoId = p2pProductinfoId == null ? null : p2pProductinfoId.trim();
    }

    public String getProductSelectId() {
        return productSelectId;
    }

    public void setProductSelectId(String productSelectId) {
        this.productSelectId = productSelectId == null ? null : productSelectId.trim();
    }

    public String getLevel() {
        return level;
    }

    public void setLevel(String level) {
        this.level = level == null ? null : level.trim();
    }

    public String getP2pProductId() {
        return p2pProductId;
    }

    public void setP2pProductId(String p2pProductId) {
        this.p2pProductId = p2pProductId == null ? null : p2pProductId.trim();
    }

    public BigDecimal getInvestmentAmount() {
        return investmentAmount;
    }

    public void setInvestmentAmount(BigDecimal investmentAmount) {
        this.investmentAmount = investmentAmount;
    }

    public Date getAddTime() {
        return addTime;
    }

    public void setAddTime(Date addTime) {
        this.addTime = addTime;
    }
}