package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class ClientWeightExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ClientWeightExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andSchoolIdIsNull() {
            addCriterion("school_id is null");
            return (Criteria) this;
        }

        public Criteria andSchoolIdIsNotNull() {
            addCriterion("school_id is not null");
            return (Criteria) this;
        }

        public Criteria andSchoolIdEqualTo(String value) {
            addCriterion("school_id =", value, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdNotEqualTo(String value) {
            addCriterion("school_id <>", value, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdGreaterThan(String value) {
            addCriterion("school_id >", value, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdGreaterThanOrEqualTo(String value) {
            addCriterion("school_id >=", value, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdLessThan(String value) {
            addCriterion("school_id <", value, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdLessThanOrEqualTo(String value) {
            addCriterion("school_id <=", value, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdLike(String value) {
            addCriterion("school_id like", value, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdNotLike(String value) {
            addCriterion("school_id not like", value, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdIn(List<String> values) {
            addCriterion("school_id in", values, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdNotIn(List<String> values) {
            addCriterion("school_id not in", values, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdBetween(String value1, String value2) {
            addCriterion("school_id between", value1, value2, "schoolId");
            return (Criteria) this;
        }

        public Criteria andSchoolIdNotBetween(String value1, String value2) {
            addCriterion("school_id not between", value1, value2, "schoolId");
            return (Criteria) this;
        }

        public Criteria andFxcpIsNull() {
            addCriterion("fxcp is null");
            return (Criteria) this;
        }

        public Criteria andFxcpIsNotNull() {
            addCriterion("fxcp is not null");
            return (Criteria) this;
        }

        public Criteria andFxcpEqualTo(BigDecimal value) {
            addCriterion("fxcp =", value, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpNotEqualTo(BigDecimal value) {
            addCriterion("fxcp <>", value, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpGreaterThan(BigDecimal value) {
            addCriterion("fxcp >", value, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fxcp >=", value, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpLessThan(BigDecimal value) {
            addCriterion("fxcp <", value, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fxcp <=", value, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpIn(List<BigDecimal> values) {
            addCriterion("fxcp in", values, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpNotIn(List<BigDecimal> values) {
            addCriterion("fxcp not in", values, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fxcp between", value1, value2, "fxcp");
            return (Criteria) this;
        }

        public Criteria andFxcpNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fxcp not between", value1, value2, "fxcp");
            return (Criteria) this;
        }

        public Criteria andCwfxIsNull() {
            addCriterion("cwfx is null");
            return (Criteria) this;
        }

        public Criteria andCwfxIsNotNull() {
            addCriterion("cwfx is not null");
            return (Criteria) this;
        }

        public Criteria andCwfxEqualTo(BigDecimal value) {
            addCriterion("cwfx =", value, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxNotEqualTo(BigDecimal value) {
            addCriterion("cwfx <>", value, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxGreaterThan(BigDecimal value) {
            addCriterion("cwfx >", value, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cwfx >=", value, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxLessThan(BigDecimal value) {
            addCriterion("cwfx <", value, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cwfx <=", value, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxIn(List<BigDecimal> values) {
            addCriterion("cwfx in", values, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxNotIn(List<BigDecimal> values) {
            addCriterion("cwfx not in", values, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cwfx between", value1, value2, "cwfx");
            return (Criteria) this;
        }

        public Criteria andCwfxNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cwfx not between", value1, value2, "cwfx");
            return (Criteria) this;
        }

        public Criteria andXjghIsNull() {
            addCriterion("xjgh is null");
            return (Criteria) this;
        }

        public Criteria andXjghIsNotNull() {
            addCriterion("xjgh is not null");
            return (Criteria) this;
        }

        public Criteria andXjghEqualTo(BigDecimal value) {
            addCriterion("xjgh =", value, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghNotEqualTo(BigDecimal value) {
            addCriterion("xjgh <>", value, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghGreaterThan(BigDecimal value) {
            addCriterion("xjgh >", value, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("xjgh >=", value, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghLessThan(BigDecimal value) {
            addCriterion("xjgh <", value, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghLessThanOrEqualTo(BigDecimal value) {
            addCriterion("xjgh <=", value, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghIn(List<BigDecimal> values) {
            addCriterion("xjgh in", values, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghNotIn(List<BigDecimal> values) {
            addCriterion("xjgh not in", values, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("xjgh between", value1, value2, "xjgh");
            return (Criteria) this;
        }

        public Criteria andXjghNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("xjgh not between", value1, value2, "xjgh");
            return (Criteria) this;
        }

        public Criteria andJyghIsNull() {
            addCriterion("jygh is null");
            return (Criteria) this;
        }

        public Criteria andJyghIsNotNull() {
            addCriterion("jygh is not null");
            return (Criteria) this;
        }

        public Criteria andJyghEqualTo(BigDecimal value) {
            addCriterion("jygh =", value, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghNotEqualTo(BigDecimal value) {
            addCriterion("jygh <>", value, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghGreaterThan(BigDecimal value) {
            addCriterion("jygh >", value, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("jygh >=", value, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghLessThan(BigDecimal value) {
            addCriterion("jygh <", value, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghLessThanOrEqualTo(BigDecimal value) {
            addCriterion("jygh <=", value, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghIn(List<BigDecimal> values) {
            addCriterion("jygh in", values, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghNotIn(List<BigDecimal> values) {
            addCriterion("jygh not in", values, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jygh between", value1, value2, "jygh");
            return (Criteria) this;
        }

        public Criteria andJyghNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("jygh not between", value1, value2, "jygh");
            return (Criteria) this;
        }

        public Criteria andXfghIsNull() {
            addCriterion("xfgh is null");
            return (Criteria) this;
        }

        public Criteria andXfghIsNotNull() {
            addCriterion("xfgh is not null");
            return (Criteria) this;
        }

        public Criteria andXfghEqualTo(BigDecimal value) {
            addCriterion("xfgh =", value, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghNotEqualTo(BigDecimal value) {
            addCriterion("xfgh <>", value, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghGreaterThan(BigDecimal value) {
            addCriterion("xfgh >", value, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("xfgh >=", value, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghLessThan(BigDecimal value) {
            addCriterion("xfgh <", value, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghLessThanOrEqualTo(BigDecimal value) {
            addCriterion("xfgh <=", value, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghIn(List<BigDecimal> values) {
            addCriterion("xfgh in", values, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghNotIn(List<BigDecimal> values) {
            addCriterion("xfgh not in", values, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("xfgh between", value1, value2, "xfgh");
            return (Criteria) this;
        }

        public Criteria andXfghNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("xfgh not between", value1, value2, "xfgh");
            return (Criteria) this;
        }

        public Criteria andCyghIsNull() {
            addCriterion("cygh is null");
            return (Criteria) this;
        }

        public Criteria andCyghIsNotNull() {
            addCriterion("cygh is not null");
            return (Criteria) this;
        }

        public Criteria andCyghEqualTo(BigDecimal value) {
            addCriterion("cygh =", value, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghNotEqualTo(BigDecimal value) {
            addCriterion("cygh <>", value, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghGreaterThan(BigDecimal value) {
            addCriterion("cygh >", value, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cygh >=", value, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghLessThan(BigDecimal value) {
            addCriterion("cygh <", value, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cygh <=", value, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghIn(List<BigDecimal> values) {
            addCriterion("cygh in", values, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghNotIn(List<BigDecimal> values) {
            addCriterion("cygh not in", values, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cygh between", value1, value2, "cygh");
            return (Criteria) this;
        }

        public Criteria andCyghNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cygh not between", value1, value2, "cygh");
            return (Criteria) this;
        }

        public Criteria andTxghIsNull() {
            addCriterion("txgh is null");
            return (Criteria) this;
        }

        public Criteria andTxghIsNotNull() {
            addCriterion("txgh is not null");
            return (Criteria) this;
        }

        public Criteria andTxghEqualTo(BigDecimal value) {
            addCriterion("txgh =", value, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghNotEqualTo(BigDecimal value) {
            addCriterion("txgh <>", value, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghGreaterThan(BigDecimal value) {
            addCriterion("txgh >", value, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("txgh >=", value, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghLessThan(BigDecimal value) {
            addCriterion("txgh <", value, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghLessThanOrEqualTo(BigDecimal value) {
            addCriterion("txgh <=", value, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghIn(List<BigDecimal> values) {
            addCriterion("txgh in", values, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghNotIn(List<BigDecimal> values) {
            addCriterion("txgh not in", values, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("txgh between", value1, value2, "txgh");
            return (Criteria) this;
        }

        public Criteria andTxghNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("txgh not between", value1, value2, "txgh");
            return (Criteria) this;
        }

        public Criteria andBxghIsNull() {
            addCriterion("bxgh is null");
            return (Criteria) this;
        }

        public Criteria andBxghIsNotNull() {
            addCriterion("bxgh is not null");
            return (Criteria) this;
        }

        public Criteria andBxghEqualTo(BigDecimal value) {
            addCriterion("bxgh =", value, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghNotEqualTo(BigDecimal value) {
            addCriterion("bxgh <>", value, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghGreaterThan(BigDecimal value) {
            addCriterion("bxgh >", value, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("bxgh >=", value, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghLessThan(BigDecimal value) {
            addCriterion("bxgh <", value, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghLessThanOrEqualTo(BigDecimal value) {
            addCriterion("bxgh <=", value, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghIn(List<BigDecimal> values) {
            addCriterion("bxgh in", values, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghNotIn(List<BigDecimal> values) {
            addCriterion("bxgh not in", values, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("bxgh between", value1, value2, "bxgh");
            return (Criteria) this;
        }

        public Criteria andBxghNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("bxgh not between", value1, value2, "bxgh");
            return (Criteria) this;
        }

        public Criteria andTzghIsNull() {
            addCriterion("tzgh is null");
            return (Criteria) this;
        }

        public Criteria andTzghIsNotNull() {
            addCriterion("tzgh is not null");
            return (Criteria) this;
        }

        public Criteria andTzghEqualTo(BigDecimal value) {
            addCriterion("tzgh =", value, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghNotEqualTo(BigDecimal value) {
            addCriterion("tzgh <>", value, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghGreaterThan(BigDecimal value) {
            addCriterion("tzgh >", value, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("tzgh >=", value, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghLessThan(BigDecimal value) {
            addCriterion("tzgh <", value, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghLessThanOrEqualTo(BigDecimal value) {
            addCriterion("tzgh <=", value, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghIn(List<BigDecimal> values) {
            addCriterion("tzgh in", values, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghNotIn(List<BigDecimal> values) {
            addCriterion("tzgh not in", values, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tzgh between", value1, value2, "tzgh");
            return (Criteria) this;
        }

        public Criteria andTzghNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tzgh not between", value1, value2, "tzgh");
            return (Criteria) this;
        }

        public Criteria andSwchIsNull() {
            addCriterion("swch is null");
            return (Criteria) this;
        }

        public Criteria andSwchIsNotNull() {
            addCriterion("swch is not null");
            return (Criteria) this;
        }

        public Criteria andSwchEqualTo(BigDecimal value) {
            addCriterion("swch =", value, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchNotEqualTo(BigDecimal value) {
            addCriterion("swch <>", value, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchGreaterThan(BigDecimal value) {
            addCriterion("swch >", value, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("swch >=", value, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchLessThan(BigDecimal value) {
            addCriterion("swch <", value, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchLessThanOrEqualTo(BigDecimal value) {
            addCriterion("swch <=", value, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchIn(List<BigDecimal> values) {
            addCriterion("swch in", values, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchNotIn(List<BigDecimal> values) {
            addCriterion("swch not in", values, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("swch between", value1, value2, "swch");
            return (Criteria) this;
        }

        public Criteria andSwchNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("swch not between", value1, value2, "swch");
            return (Criteria) this;
        }

        public Criteria andCcfpIsNull() {
            addCriterion("ccfp is null");
            return (Criteria) this;
        }

        public Criteria andCcfpIsNotNull() {
            addCriterion("ccfp is not null");
            return (Criteria) this;
        }

        public Criteria andCcfpEqualTo(BigDecimal value) {
            addCriterion("ccfp =", value, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpNotEqualTo(BigDecimal value) {
            addCriterion("ccfp <>", value, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpGreaterThan(BigDecimal value) {
            addCriterion("ccfp >", value, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ccfp >=", value, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpLessThan(BigDecimal value) {
            addCriterion("ccfp <", value, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ccfp <=", value, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpIn(List<BigDecimal> values) {
            addCriterion("ccfp in", values, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpNotIn(List<BigDecimal> values) {
            addCriterion("ccfp not in", values, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ccfp between", value1, value2, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcfpNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ccfp not between", value1, value2, "ccfp");
            return (Criteria) this;
        }

        public Criteria andCcccIsNull() {
            addCriterion("cccc is null");
            return (Criteria) this;
        }

        public Criteria andCcccIsNotNull() {
            addCriterion("cccc is not null");
            return (Criteria) this;
        }

        public Criteria andCcccEqualTo(BigDecimal value) {
            addCriterion("cccc =", value, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccNotEqualTo(BigDecimal value) {
            addCriterion("cccc <>", value, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccGreaterThan(BigDecimal value) {
            addCriterion("cccc >", value, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cccc >=", value, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccLessThan(BigDecimal value) {
            addCriterion("cccc <", value, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cccc <=", value, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccIn(List<BigDecimal> values) {
            addCriterion("cccc in", values, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccNotIn(List<BigDecimal> values) {
            addCriterion("cccc not in", values, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cccc between", value1, value2, "cccc");
            return (Criteria) this;
        }

        public Criteria andCcccNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cccc not between", value1, value2, "cccc");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}