package com.sztzjy.money_management.entity.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Data
@NoArgsConstructor
public class StuTrainingDto {
    @ApiModelProperty("知识概要默认计分规则")
    private BigDecimal knowledgeSummaryDefaultRule;

    @ApiModelProperty("资源学习默认计分规则")
    private BigDecimal resourceLearningDefaultRule;

    @ApiModelProperty("学习测评默认计分规则")
    private BigDecimal learningEvalDefaultRule;

    @ApiModelProperty("实验实训默认计分规则")
    private BigDecimal expTrainingDefautRule;


    @ApiModelProperty("知识概要权重")
    private BigDecimal knowledgeSummaryWeight;

    @ApiModelProperty("资源学习权重")
    private BigDecimal resourceLearningWeight;

    @ApiModelProperty("学习测评权重")
    private BigDecimal learningEvalWeight;

    @ApiModelProperty("实验实训权重")
    private BigDecimal expTrainingWeight;

    @ApiModelProperty("实验报告权重")
    private BigDecimal reportWeight;


    @ApiModelProperty("知识概要完成情况")
    private Integer knowledgeSummaryCompleteStatus;

    @ApiModelProperty("资源学习完成情况")
    private Integer resourceLearningCompleteStatus;

    @ApiModelProperty("学习评测完成情况")
    private Integer learningEvalCompleteStatus;

    @ApiModelProperty("实验实训完成情况")
    private Integer expTrainingCompleteStatus;

    @ApiModelProperty("实验报告完成情况")
    private String reportCompleteStatus;



    @ApiModelProperty("知识概要总分")
    private BigDecimal knowledgeSummaryScore;

    @ApiModelProperty("资源学习总分")
    private BigDecimal resourceLearningScore;

    @ApiModelProperty("学习评测总分")
    private BigDecimal learningEvalScore;

    @ApiModelProperty("案例题学生总分")
    private BigDecimal caseStuScore;

    @ApiModelProperty("实验报告总分")
    private BigDecimal reportScore;


}
