package com.sztzjy.money_management.entity;

import java.math.BigDecimal;

import io.swagger.annotations.ApiModelProperty;
/**
 * 案例现金规划表
 *
 * @author xcj
 * case_cash_plan
 */
public class CaseCashPlan {
    @ApiModelProperty("案例现金规划id")
    private String caseCashPlanId;

    private String caseid;

    @ApiModelProperty("家庭月支出")
    private BigDecimal familyMonthExpense;

    @ApiModelProperty("现金保留规模")
    private String retainCashType;

    @ApiModelProperty("活期存款")
    private BigDecimal deposit;

    @ApiModelProperty("货币市场基金")
    private BigDecimal fund;

    @ApiModelProperty("信用卡")
    private BigDecimal creditCard;

    @ApiModelProperty("用户ID")
    private String userId;

    @ApiModelProperty("学生答案/题目答案")
    private String isAnswer;

    @ApiModelProperty("现金规划分析老师评分")
    private BigDecimal analysisTeacherScore;

    @ApiModelProperty("现金规划分析")
    private String analysis;

    public String getCaseCashPlanId() {
        return caseCashPlanId;
    }

    public void setCaseCashPlanId(String caseCashPlanId) {
        this.caseCashPlanId = caseCashPlanId == null ? null : caseCashPlanId.trim();
    }

    public String getCaseid() {
        return caseid;
    }

    public void setCaseid(String caseid) {
        this.caseid = caseid == null ? null : caseid.trim();
    }

    public BigDecimal getFamilyMonthExpense() {
        return familyMonthExpense;
    }

    public void setFamilyMonthExpense(BigDecimal familyMonthExpense) {
        this.familyMonthExpense = familyMonthExpense;
    }

    public String getRetainCashType() {
        return retainCashType;
    }

    public void setRetainCashType(String retainCashType) {
        this.retainCashType = retainCashType == null ? null : retainCashType.trim();
    }

    public BigDecimal getDeposit() {
        return deposit;
    }

    public void setDeposit(BigDecimal deposit) {
        this.deposit = deposit;
    }

    public BigDecimal getFund() {
        return fund;
    }

    public void setFund(BigDecimal fund) {
        this.fund = fund;
    }

    public BigDecimal getCreditCard() {
        return creditCard;
    }

    public void setCreditCard(BigDecimal creditCard) {
        this.creditCard = creditCard;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId == null ? null : userId.trim();
    }

    public String getIsAnswer() {
        return isAnswer;
    }

    public void setIsAnswer(String isAnswer) {
        this.isAnswer = isAnswer == null ? null : isAnswer.trim();
    }

    public BigDecimal getAnalysisTeacherScore() {
        return analysisTeacherScore;
    }

    public void setAnalysisTeacherScore(BigDecimal analysisTeacherScore) {
        this.analysisTeacherScore = analysisTeacherScore;
    }

    public String getAnalysis() {
        return analysis;
    }

    public void setAnalysis(String analysis) {
        this.analysis = analysis == null ? null : analysis.trim();
    }
}