package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class CaseInvestmentPlanExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CaseInvestmentPlanExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andCaseInvestmentPlanIdIsNull() {
            addCriterion("case_investment_plan_id is null");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdIsNotNull() {
            addCriterion("case_investment_plan_id is not null");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdEqualTo(String value) {
            addCriterion("case_investment_plan_id =", value, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdNotEqualTo(String value) {
            addCriterion("case_investment_plan_id <>", value, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdGreaterThan(String value) {
            addCriterion("case_investment_plan_id >", value, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdGreaterThanOrEqualTo(String value) {
            addCriterion("case_investment_plan_id >=", value, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdLessThan(String value) {
            addCriterion("case_investment_plan_id <", value, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdLessThanOrEqualTo(String value) {
            addCriterion("case_investment_plan_id <=", value, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdLike(String value) {
            addCriterion("case_investment_plan_id like", value, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdNotLike(String value) {
            addCriterion("case_investment_plan_id not like", value, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdIn(List<String> values) {
            addCriterion("case_investment_plan_id in", values, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdNotIn(List<String> values) {
            addCriterion("case_investment_plan_id not in", values, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdBetween(String value1, String value2) {
            addCriterion("case_investment_plan_id between", value1, value2, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseInvestmentPlanIdNotBetween(String value1, String value2) {
            addCriterion("case_investment_plan_id not between", value1, value2, "caseInvestmentPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseIdIsNull() {
            addCriterion("case_id is null");
            return (Criteria) this;
        }

        public Criteria andCaseIdIsNotNull() {
            addCriterion("case_id is not null");
            return (Criteria) this;
        }

        public Criteria andCaseIdEqualTo(String value) {
            addCriterion("case_id =", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdNotEqualTo(String value) {
            addCriterion("case_id <>", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdGreaterThan(String value) {
            addCriterion("case_id >", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdGreaterThanOrEqualTo(String value) {
            addCriterion("case_id >=", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdLessThan(String value) {
            addCriterion("case_id <", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdLessThanOrEqualTo(String value) {
            addCriterion("case_id <=", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdLike(String value) {
            addCriterion("case_id like", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdNotLike(String value) {
            addCriterion("case_id not like", value, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdIn(List<String> values) {
            addCriterion("case_id in", values, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdNotIn(List<String> values) {
            addCriterion("case_id not in", values, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdBetween(String value1, String value2) {
            addCriterion("case_id between", value1, value2, "caseId");
            return (Criteria) this;
        }

        public Criteria andCaseIdNotBetween(String value1, String value2) {
            addCriterion("case_id not between", value1, value2, "caseId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdIsNull() {
            addCriterion("life_cycle_id is null");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdIsNotNull() {
            addCriterion("life_cycle_id is not null");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdEqualTo(String value) {
            addCriterion("life_cycle_id =", value, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdNotEqualTo(String value) {
            addCriterion("life_cycle_id <>", value, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdGreaterThan(String value) {
            addCriterion("life_cycle_id >", value, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdGreaterThanOrEqualTo(String value) {
            addCriterion("life_cycle_id >=", value, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdLessThan(String value) {
            addCriterion("life_cycle_id <", value, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdLessThanOrEqualTo(String value) {
            addCriterion("life_cycle_id <=", value, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdLike(String value) {
            addCriterion("life_cycle_id like", value, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdNotLike(String value) {
            addCriterion("life_cycle_id not like", value, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdIn(List<String> values) {
            addCriterion("life_cycle_id in", values, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdNotIn(List<String> values) {
            addCriterion("life_cycle_id not in", values, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdBetween(String value1, String value2) {
            addCriterion("life_cycle_id between", value1, value2, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andLifeCycleIdNotBetween(String value1, String value2) {
            addCriterion("life_cycle_id not between", value1, value2, "lifeCycleId");
            return (Criteria) this;
        }

        public Criteria andHoldRateIsNull() {
            addCriterion("hold_rate is null");
            return (Criteria) this;
        }

        public Criteria andHoldRateIsNotNull() {
            addCriterion("hold_rate is not null");
            return (Criteria) this;
        }

        public Criteria andHoldRateEqualTo(BigDecimal value) {
            addCriterion("hold_rate =", value, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateNotEqualTo(BigDecimal value) {
            addCriterion("hold_rate <>", value, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateGreaterThan(BigDecimal value) {
            addCriterion("hold_rate >", value, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("hold_rate >=", value, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateLessThan(BigDecimal value) {
            addCriterion("hold_rate <", value, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("hold_rate <=", value, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateIn(List<BigDecimal> values) {
            addCriterion("hold_rate in", values, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateNotIn(List<BigDecimal> values) {
            addCriterion("hold_rate not in", values, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hold_rate between", value1, value2, "holdRate");
            return (Criteria) this;
        }

        public Criteria andHoldRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hold_rate not between", value1, value2, "holdRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateIsNull() {
            addCriterion("increase_rate is null");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateIsNotNull() {
            addCriterion("increase_rate is not null");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateEqualTo(BigDecimal value) {
            addCriterion("increase_rate =", value, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateNotEqualTo(BigDecimal value) {
            addCriterion("increase_rate <>", value, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateGreaterThan(BigDecimal value) {
            addCriterion("increase_rate >", value, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("increase_rate >=", value, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateLessThan(BigDecimal value) {
            addCriterion("increase_rate <", value, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("increase_rate <=", value, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateIn(List<BigDecimal> values) {
            addCriterion("increase_rate in", values, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateNotIn(List<BigDecimal> values) {
            addCriterion("increase_rate not in", values, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("increase_rate between", value1, value2, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andIncreaseRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("increase_rate not between", value1, value2, "increaseRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateIsNull() {
            addCriterion("speculation_rate is null");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateIsNotNull() {
            addCriterion("speculation_rate is not null");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateEqualTo(BigDecimal value) {
            addCriterion("speculation_rate =", value, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateNotEqualTo(BigDecimal value) {
            addCriterion("speculation_rate <>", value, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateGreaterThan(BigDecimal value) {
            addCriterion("speculation_rate >", value, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("speculation_rate >=", value, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateLessThan(BigDecimal value) {
            addCriterion("speculation_rate <", value, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("speculation_rate <=", value, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateIn(List<BigDecimal> values) {
            addCriterion("speculation_rate in", values, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateNotIn(List<BigDecimal> values) {
            addCriterion("speculation_rate not in", values, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("speculation_rate between", value1, value2, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andSpeculationRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("speculation_rate not between", value1, value2, "speculationRate");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNull() {
            addCriterion("is_answer is null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNotNull() {
            addCriterion("is_answer is not null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerEqualTo(String value) {
            addCriterion("is_answer =", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotEqualTo(String value) {
            addCriterion("is_answer <>", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThan(String value) {
            addCriterion("is_answer >", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThanOrEqualTo(String value) {
            addCriterion("is_answer >=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThan(String value) {
            addCriterion("is_answer <", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThanOrEqualTo(String value) {
            addCriterion("is_answer <=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLike(String value) {
            addCriterion("is_answer like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotLike(String value) {
            addCriterion("is_answer not like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIn(List<String> values) {
            addCriterion("is_answer in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotIn(List<String> values) {
            addCriterion("is_answer not in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerBetween(String value1, String value2) {
            addCriterion("is_answer between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotBetween(String value1, String value2) {
            addCriterion("is_answer not between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIsNull() {
            addCriterion("analysis_teacher_score is null");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIsNotNull() {
            addCriterion("analysis_teacher_score is not null");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score =", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score <>", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreGreaterThan(BigDecimal value) {
            addCriterion("analysis_teacher_score >", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score >=", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreLessThan(BigDecimal value) {
            addCriterion("analysis_teacher_score <", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score <=", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIn(List<BigDecimal> values) {
            addCriterion("analysis_teacher_score in", values, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotIn(List<BigDecimal> values) {
            addCriterion("analysis_teacher_score not in", values, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("analysis_teacher_score between", value1, value2, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("analysis_teacher_score not between", value1, value2, "analysisTeacherScore");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}