package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class CaseRetirementPlanExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CaseRetirementPlanExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andCaseRetirementPlanIdIsNull() {
            addCriterion("case_retirement_plan_id is null");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdIsNotNull() {
            addCriterion("case_retirement_plan_id is not null");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdEqualTo(String value) {
            addCriterion("case_retirement_plan_id =", value, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdNotEqualTo(String value) {
            addCriterion("case_retirement_plan_id <>", value, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdGreaterThan(String value) {
            addCriterion("case_retirement_plan_id >", value, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdGreaterThanOrEqualTo(String value) {
            addCriterion("case_retirement_plan_id >=", value, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdLessThan(String value) {
            addCriterion("case_retirement_plan_id <", value, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdLessThanOrEqualTo(String value) {
            addCriterion("case_retirement_plan_id <=", value, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdLike(String value) {
            addCriterion("case_retirement_plan_id like", value, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdNotLike(String value) {
            addCriterion("case_retirement_plan_id not like", value, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdIn(List<String> values) {
            addCriterion("case_retirement_plan_id in", values, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdNotIn(List<String> values) {
            addCriterion("case_retirement_plan_id not in", values, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdBetween(String value1, String value2) {
            addCriterion("case_retirement_plan_id between", value1, value2, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseRetirementPlanIdNotBetween(String value1, String value2) {
            addCriterion("case_retirement_plan_id not between", value1, value2, "caseRetirementPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseidIsNull() {
            addCriterion("caseid is null");
            return (Criteria) this;
        }

        public Criteria andCaseidIsNotNull() {
            addCriterion("caseid is not null");
            return (Criteria) this;
        }

        public Criteria andCaseidEqualTo(String value) {
            addCriterion("caseid =", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotEqualTo(String value) {
            addCriterion("caseid <>", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidGreaterThan(String value) {
            addCriterion("caseid >", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidGreaterThanOrEqualTo(String value) {
            addCriterion("caseid >=", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLessThan(String value) {
            addCriterion("caseid <", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLessThanOrEqualTo(String value) {
            addCriterion("caseid <=", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLike(String value) {
            addCriterion("caseid like", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotLike(String value) {
            addCriterion("caseid not like", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidIn(List<String> values) {
            addCriterion("caseid in", values, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotIn(List<String> values) {
            addCriterion("caseid not in", values, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidBetween(String value1, String value2) {
            addCriterion("caseid between", value1, value2, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotBetween(String value1, String value2) {
            addCriterion("caseid not between", value1, value2, "caseid");
            return (Criteria) this;
        }

        public Criteria andAgeIsNull() {
            addCriterion("age is null");
            return (Criteria) this;
        }

        public Criteria andAgeIsNotNull() {
            addCriterion("age is not null");
            return (Criteria) this;
        }

        public Criteria andAgeEqualTo(Integer value) {
            addCriterion("age =", value, "age");
            return (Criteria) this;
        }

        public Criteria andAgeNotEqualTo(Integer value) {
            addCriterion("age <>", value, "age");
            return (Criteria) this;
        }

        public Criteria andAgeGreaterThan(Integer value) {
            addCriterion("age >", value, "age");
            return (Criteria) this;
        }

        public Criteria andAgeGreaterThanOrEqualTo(Integer value) {
            addCriterion("age >=", value, "age");
            return (Criteria) this;
        }

        public Criteria andAgeLessThan(Integer value) {
            addCriterion("age <", value, "age");
            return (Criteria) this;
        }

        public Criteria andAgeLessThanOrEqualTo(Integer value) {
            addCriterion("age <=", value, "age");
            return (Criteria) this;
        }

        public Criteria andAgeIn(List<Integer> values) {
            addCriterion("age in", values, "age");
            return (Criteria) this;
        }

        public Criteria andAgeNotIn(List<Integer> values) {
            addCriterion("age not in", values, "age");
            return (Criteria) this;
        }

        public Criteria andAgeBetween(Integer value1, Integer value2) {
            addCriterion("age between", value1, value2, "age");
            return (Criteria) this;
        }

        public Criteria andAgeNotBetween(Integer value1, Integer value2) {
            addCriterion("age not between", value1, value2, "age");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateIsNull() {
            addCriterion("before_inflation_rate is null");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateIsNotNull() {
            addCriterion("before_inflation_rate is not null");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateEqualTo(BigDecimal value) {
            addCriterion("before_inflation_rate =", value, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateNotEqualTo(BigDecimal value) {
            addCriterion("before_inflation_rate <>", value, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateGreaterThan(BigDecimal value) {
            addCriterion("before_inflation_rate >", value, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("before_inflation_rate >=", value, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateLessThan(BigDecimal value) {
            addCriterion("before_inflation_rate <", value, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("before_inflation_rate <=", value, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateIn(List<BigDecimal> values) {
            addCriterion("before_inflation_rate in", values, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateNotIn(List<BigDecimal> values) {
            addCriterion("before_inflation_rate not in", values, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("before_inflation_rate between", value1, value2, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andBeforeInflationRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("before_inflation_rate not between", value1, value2, "beforeInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateIsNull() {
            addCriterion("after_inflation_rate is null");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateIsNotNull() {
            addCriterion("after_inflation_rate is not null");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateEqualTo(BigDecimal value) {
            addCriterion("after_inflation_rate =", value, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateNotEqualTo(BigDecimal value) {
            addCriterion("after_inflation_rate <>", value, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateGreaterThan(BigDecimal value) {
            addCriterion("after_inflation_rate >", value, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("after_inflation_rate >=", value, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateLessThan(BigDecimal value) {
            addCriterion("after_inflation_rate <", value, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("after_inflation_rate <=", value, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateIn(List<BigDecimal> values) {
            addCriterion("after_inflation_rate in", values, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateNotIn(List<BigDecimal> values) {
            addCriterion("after_inflation_rate not in", values, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("after_inflation_rate between", value1, value2, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andAfterInflationRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("after_inflation_rate not between", value1, value2, "afterInflationRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateIsNull() {
            addCriterion("retirement_rate is null");
            return (Criteria) this;
        }

        public Criteria andRetirementRateIsNotNull() {
            addCriterion("retirement_rate is not null");
            return (Criteria) this;
        }

        public Criteria andRetirementRateEqualTo(BigDecimal value) {
            addCriterion("retirement_rate =", value, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateNotEqualTo(BigDecimal value) {
            addCriterion("retirement_rate <>", value, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateGreaterThan(BigDecimal value) {
            addCriterion("retirement_rate >", value, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("retirement_rate >=", value, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateLessThan(BigDecimal value) {
            addCriterion("retirement_rate <", value, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("retirement_rate <=", value, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateIn(List<BigDecimal> values) {
            addCriterion("retirement_rate in", values, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateNotIn(List<BigDecimal> values) {
            addCriterion("retirement_rate not in", values, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("retirement_rate between", value1, value2, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andRetirementRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("retirement_rate not between", value1, value2, "retirementRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateIsNull() {
            addCriterion("socia_security_rate is null");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateIsNotNull() {
            addCriterion("socia_security_rate is not null");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateEqualTo(BigDecimal value) {
            addCriterion("socia_security_rate =", value, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateNotEqualTo(BigDecimal value) {
            addCriterion("socia_security_rate <>", value, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateGreaterThan(BigDecimal value) {
            addCriterion("socia_security_rate >", value, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("socia_security_rate >=", value, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateLessThan(BigDecimal value) {
            addCriterion("socia_security_rate <", value, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("socia_security_rate <=", value, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateIn(List<BigDecimal> values) {
            addCriterion("socia_security_rate in", values, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateNotIn(List<BigDecimal> values) {
            addCriterion("socia_security_rate not in", values, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("socia_security_rate between", value1, value2, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andSociaSecurityRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("socia_security_rate not between", value1, value2, "sociaSecurityRate");
            return (Criteria) this;
        }

        public Criteria andRentRateIsNull() {
            addCriterion("rent_rate is null");
            return (Criteria) this;
        }

        public Criteria andRentRateIsNotNull() {
            addCriterion("rent_rate is not null");
            return (Criteria) this;
        }

        public Criteria andRentRateEqualTo(BigDecimal value) {
            addCriterion("rent_rate =", value, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateNotEqualTo(BigDecimal value) {
            addCriterion("rent_rate <>", value, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateGreaterThan(BigDecimal value) {
            addCriterion("rent_rate >", value, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("rent_rate >=", value, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateLessThan(BigDecimal value) {
            addCriterion("rent_rate <", value, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("rent_rate <=", value, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateIn(List<BigDecimal> values) {
            addCriterion("rent_rate in", values, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateNotIn(List<BigDecimal> values) {
            addCriterion("rent_rate not in", values, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("rent_rate between", value1, value2, "rentRate");
            return (Criteria) this;
        }

        public Criteria andRentRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("rent_rate not between", value1, value2, "rentRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateIsNull() {
            addCriterion("other_rate is null");
            return (Criteria) this;
        }

        public Criteria andOtherRateIsNotNull() {
            addCriterion("other_rate is not null");
            return (Criteria) this;
        }

        public Criteria andOtherRateEqualTo(BigDecimal value) {
            addCriterion("other_rate =", value, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateNotEqualTo(BigDecimal value) {
            addCriterion("other_rate <>", value, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateGreaterThan(BigDecimal value) {
            addCriterion("other_rate >", value, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("other_rate >=", value, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateLessThan(BigDecimal value) {
            addCriterion("other_rate <", value, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("other_rate <=", value, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateIn(List<BigDecimal> values) {
            addCriterion("other_rate in", values, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateNotIn(List<BigDecimal> values) {
            addCriterion("other_rate not in", values, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("other_rate between", value1, value2, "otherRate");
            return (Criteria) this;
        }

        public Criteria andOtherRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("other_rate not between", value1, value2, "otherRate");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeIsNull() {
            addCriterion("retirement_age is null");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeIsNotNull() {
            addCriterion("retirement_age is not null");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeEqualTo(Integer value) {
            addCriterion("retirement_age =", value, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeNotEqualTo(Integer value) {
            addCriterion("retirement_age <>", value, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeGreaterThan(Integer value) {
            addCriterion("retirement_age >", value, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeGreaterThanOrEqualTo(Integer value) {
            addCriterion("retirement_age >=", value, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeLessThan(Integer value) {
            addCriterion("retirement_age <", value, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeLessThanOrEqualTo(Integer value) {
            addCriterion("retirement_age <=", value, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeIn(List<Integer> values) {
            addCriterion("retirement_age in", values, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeNotIn(List<Integer> values) {
            addCriterion("retirement_age not in", values, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeBetween(Integer value1, Integer value2) {
            addCriterion("retirement_age between", value1, value2, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementAgeNotBetween(Integer value1, Integer value2) {
            addCriterion("retirement_age not between", value1, value2, "retirementAge");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsIsNull() {
            addCriterion("retirement_years is null");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsIsNotNull() {
            addCriterion("retirement_years is not null");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsEqualTo(Integer value) {
            addCriterion("retirement_years =", value, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsNotEqualTo(Integer value) {
            addCriterion("retirement_years <>", value, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsGreaterThan(Integer value) {
            addCriterion("retirement_years >", value, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsGreaterThanOrEqualTo(Integer value) {
            addCriterion("retirement_years >=", value, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsLessThan(Integer value) {
            addCriterion("retirement_years <", value, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsLessThanOrEqualTo(Integer value) {
            addCriterion("retirement_years <=", value, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsIn(List<Integer> values) {
            addCriterion("retirement_years in", values, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsNotIn(List<Integer> values) {
            addCriterion("retirement_years not in", values, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsBetween(Integer value1, Integer value2) {
            addCriterion("retirement_years between", value1, value2, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andRetirementYearsNotBetween(Integer value1, Integer value2) {
            addCriterion("retirement_years not between", value1, value2, "retirementYears");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowIsNull() {
            addCriterion("living_standard_now is null");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowIsNotNull() {
            addCriterion("living_standard_now is not null");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowEqualTo(String value) {
            addCriterion("living_standard_now =", value, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowNotEqualTo(String value) {
            addCriterion("living_standard_now <>", value, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowGreaterThan(String value) {
            addCriterion("living_standard_now >", value, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowGreaterThanOrEqualTo(String value) {
            addCriterion("living_standard_now >=", value, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowLessThan(String value) {
            addCriterion("living_standard_now <", value, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowLessThanOrEqualTo(String value) {
            addCriterion("living_standard_now <=", value, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowLike(String value) {
            addCriterion("living_standard_now like", value, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowNotLike(String value) {
            addCriterion("living_standard_now not like", value, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowIn(List<String> values) {
            addCriterion("living_standard_now in", values, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowNotIn(List<String> values) {
            addCriterion("living_standard_now not in", values, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowBetween(String value1, String value2) {
            addCriterion("living_standard_now between", value1, value2, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andLivingStandardNowNotBetween(String value1, String value2) {
            addCriterion("living_standard_now not between", value1, value2, "livingStandardNow");
            return (Criteria) this;
        }

        public Criteria andSatisfactionIsNull() {
            addCriterion("satisfaction is null");
            return (Criteria) this;
        }

        public Criteria andSatisfactionIsNotNull() {
            addCriterion("satisfaction is not null");
            return (Criteria) this;
        }

        public Criteria andSatisfactionEqualTo(Integer value) {
            addCriterion("satisfaction =", value, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionNotEqualTo(Integer value) {
            addCriterion("satisfaction <>", value, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionGreaterThan(Integer value) {
            addCriterion("satisfaction >", value, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionGreaterThanOrEqualTo(Integer value) {
            addCriterion("satisfaction >=", value, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLessThan(Integer value) {
            addCriterion("satisfaction <", value, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLessThanOrEqualTo(Integer value) {
            addCriterion("satisfaction <=", value, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionIn(List<Integer> values) {
            addCriterion("satisfaction in", values, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionNotIn(List<Integer> values) {
            addCriterion("satisfaction not in", values, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionBetween(Integer value1, Integer value2) {
            addCriterion("satisfaction between", value1, value2, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionNotBetween(Integer value1, Integer value2) {
            addCriterion("satisfaction not between", value1, value2, "satisfaction");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardIsNull() {
            addCriterion("satisfaction_living_standard is null");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardIsNotNull() {
            addCriterion("satisfaction_living_standard is not null");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardEqualTo(String value) {
            addCriterion("satisfaction_living_standard =", value, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardNotEqualTo(String value) {
            addCriterion("satisfaction_living_standard <>", value, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardGreaterThan(String value) {
            addCriterion("satisfaction_living_standard >", value, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardGreaterThanOrEqualTo(String value) {
            addCriterion("satisfaction_living_standard >=", value, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardLessThan(String value) {
            addCriterion("satisfaction_living_standard <", value, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardLessThanOrEqualTo(String value) {
            addCriterion("satisfaction_living_standard <=", value, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardLike(String value) {
            addCriterion("satisfaction_living_standard like", value, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardNotLike(String value) {
            addCriterion("satisfaction_living_standard not like", value, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardIn(List<String> values) {
            addCriterion("satisfaction_living_standard in", values, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardNotIn(List<String> values) {
            addCriterion("satisfaction_living_standard not in", values, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardBetween(String value1, String value2) {
            addCriterion("satisfaction_living_standard between", value1, value2, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSatisfactionLivingStandardNotBetween(String value1, String value2) {
            addCriterion("satisfaction_living_standard not between", value1, value2, "satisfactionLivingStandard");
            return (Criteria) this;
        }

        public Criteria andConvertProportionIsNull() {
            addCriterion("convert_proportion is null");
            return (Criteria) this;
        }

        public Criteria andConvertProportionIsNotNull() {
            addCriterion("convert_proportion is not null");
            return (Criteria) this;
        }

        public Criteria andConvertProportionEqualTo(BigDecimal value) {
            addCriterion("convert_proportion =", value, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionNotEqualTo(BigDecimal value) {
            addCriterion("convert_proportion <>", value, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionGreaterThan(BigDecimal value) {
            addCriterion("convert_proportion >", value, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("convert_proportion >=", value, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionLessThan(BigDecimal value) {
            addCriterion("convert_proportion <", value, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionLessThanOrEqualTo(BigDecimal value) {
            addCriterion("convert_proportion <=", value, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionIn(List<BigDecimal> values) {
            addCriterion("convert_proportion in", values, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionNotIn(List<BigDecimal> values) {
            addCriterion("convert_proportion not in", values, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("convert_proportion between", value1, value2, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andConvertProportionNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("convert_proportion not between", value1, value2, "convertProportion");
            return (Criteria) this;
        }

        public Criteria andLineageFeeIsNull() {
            addCriterion("lineage_fee is null");
            return (Criteria) this;
        }

        public Criteria andLineageFeeIsNotNull() {
            addCriterion("lineage_fee is not null");
            return (Criteria) this;
        }

        public Criteria andLineageFeeEqualTo(BigDecimal value) {
            addCriterion("lineage_fee =", value, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeNotEqualTo(BigDecimal value) {
            addCriterion("lineage_fee <>", value, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeGreaterThan(BigDecimal value) {
            addCriterion("lineage_fee >", value, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("lineage_fee >=", value, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeLessThan(BigDecimal value) {
            addCriterion("lineage_fee <", value, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("lineage_fee <=", value, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeIn(List<BigDecimal> values) {
            addCriterion("lineage_fee in", values, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeNotIn(List<BigDecimal> values) {
            addCriterion("lineage_fee not in", values, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lineage_fee between", value1, value2, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andLineageFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("lineage_fee not between", value1, value2, "lineageFee");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardIsNull() {
            addCriterion("retirement_living_standard is null");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardIsNotNull() {
            addCriterion("retirement_living_standard is not null");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardEqualTo(String value) {
            addCriterion("retirement_living_standard =", value, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardNotEqualTo(String value) {
            addCriterion("retirement_living_standard <>", value, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardGreaterThan(String value) {
            addCriterion("retirement_living_standard >", value, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardGreaterThanOrEqualTo(String value) {
            addCriterion("retirement_living_standard >=", value, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardLessThan(String value) {
            addCriterion("retirement_living_standard <", value, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardLessThanOrEqualTo(String value) {
            addCriterion("retirement_living_standard <=", value, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardLike(String value) {
            addCriterion("retirement_living_standard like", value, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardNotLike(String value) {
            addCriterion("retirement_living_standard not like", value, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardIn(List<String> values) {
            addCriterion("retirement_living_standard in", values, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardNotIn(List<String> values) {
            addCriterion("retirement_living_standard not in", values, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardBetween(String value1, String value2) {
            addCriterion("retirement_living_standard between", value1, value2, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andRetirementLivingStandardNotBetween(String value1, String value2) {
            addCriterion("retirement_living_standard not between", value1, value2, "retirementLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardIsNull() {
            addCriterion("after_living_standard is null");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardIsNotNull() {
            addCriterion("after_living_standard is not null");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardEqualTo(String value) {
            addCriterion("after_living_standard =", value, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardNotEqualTo(String value) {
            addCriterion("after_living_standard <>", value, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardGreaterThan(String value) {
            addCriterion("after_living_standard >", value, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardGreaterThanOrEqualTo(String value) {
            addCriterion("after_living_standard >=", value, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardLessThan(String value) {
            addCriterion("after_living_standard <", value, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardLessThanOrEqualTo(String value) {
            addCriterion("after_living_standard <=", value, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardLike(String value) {
            addCriterion("after_living_standard like", value, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardNotLike(String value) {
            addCriterion("after_living_standard not like", value, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardIn(List<String> values) {
            addCriterion("after_living_standard in", values, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardNotIn(List<String> values) {
            addCriterion("after_living_standard not in", values, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardBetween(String value1, String value2) {
            addCriterion("after_living_standard between", value1, value2, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andAfterLivingStandardNotBetween(String value1, String value2) {
            addCriterion("after_living_standard not between", value1, value2, "afterLivingStandard");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceIsNull() {
            addCriterion("social_insurance is null");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceIsNotNull() {
            addCriterion("social_insurance is not null");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceEqualTo(BigDecimal value) {
            addCriterion("social_insurance =", value, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceNotEqualTo(BigDecimal value) {
            addCriterion("social_insurance <>", value, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceGreaterThan(BigDecimal value) {
            addCriterion("social_insurance >", value, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("social_insurance >=", value, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceLessThan(BigDecimal value) {
            addCriterion("social_insurance <", value, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("social_insurance <=", value, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceIn(List<BigDecimal> values) {
            addCriterion("social_insurance in", values, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceNotIn(List<BigDecimal> values) {
            addCriterion("social_insurance not in", values, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("social_insurance between", value1, value2, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andSocialInsuranceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("social_insurance not between", value1, value2, "socialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceIsNull() {
            addCriterion("commercial_insurance is null");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceIsNotNull() {
            addCriterion("commercial_insurance is not null");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceEqualTo(BigDecimal value) {
            addCriterion("commercial_insurance =", value, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceNotEqualTo(BigDecimal value) {
            addCriterion("commercial_insurance <>", value, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceGreaterThan(BigDecimal value) {
            addCriterion("commercial_insurance >", value, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("commercial_insurance >=", value, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceLessThan(BigDecimal value) {
            addCriterion("commercial_insurance <", value, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("commercial_insurance <=", value, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceIn(List<BigDecimal> values) {
            addCriterion("commercial_insurance in", values, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceNotIn(List<BigDecimal> values) {
            addCriterion("commercial_insurance not in", values, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("commercial_insurance between", value1, value2, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andCommercialInsuranceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("commercial_insurance not between", value1, value2, "commercialInsurance");
            return (Criteria) this;
        }

        public Criteria andRentIncomeIsNull() {
            addCriterion("rent_income is null");
            return (Criteria) this;
        }

        public Criteria andRentIncomeIsNotNull() {
            addCriterion("rent_income is not null");
            return (Criteria) this;
        }

        public Criteria andRentIncomeEqualTo(BigDecimal value) {
            addCriterion("rent_income =", value, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeNotEqualTo(BigDecimal value) {
            addCriterion("rent_income <>", value, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeGreaterThan(BigDecimal value) {
            addCriterion("rent_income >", value, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("rent_income >=", value, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeLessThan(BigDecimal value) {
            addCriterion("rent_income <", value, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("rent_income <=", value, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeIn(List<BigDecimal> values) {
            addCriterion("rent_income in", values, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeNotIn(List<BigDecimal> values) {
            addCriterion("rent_income not in", values, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("rent_income between", value1, value2, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andRentIncomeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("rent_income not between", value1, value2, "rentIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeIsNull() {
            addCriterion("other_income is null");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeIsNotNull() {
            addCriterion("other_income is not null");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeEqualTo(BigDecimal value) {
            addCriterion("other_income =", value, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeNotEqualTo(BigDecimal value) {
            addCriterion("other_income <>", value, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeGreaterThan(BigDecimal value) {
            addCriterion("other_income >", value, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("other_income >=", value, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeLessThan(BigDecimal value) {
            addCriterion("other_income <", value, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("other_income <=", value, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeIn(List<BigDecimal> values) {
            addCriterion("other_income in", values, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeNotIn(List<BigDecimal> values) {
            addCriterion("other_income not in", values, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("other_income between", value1, value2, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andOtherIncomeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("other_income not between", value1, value2, "otherIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeIsNull() {
            addCriterion("total_income is null");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeIsNotNull() {
            addCriterion("total_income is not null");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeEqualTo(BigDecimal value) {
            addCriterion("total_income =", value, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeNotEqualTo(BigDecimal value) {
            addCriterion("total_income <>", value, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeGreaterThan(BigDecimal value) {
            addCriterion("total_income >", value, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_income >=", value, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeLessThan(BigDecimal value) {
            addCriterion("total_income <", value, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_income <=", value, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeIn(List<BigDecimal> values) {
            addCriterion("total_income in", values, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeNotIn(List<BigDecimal> values) {
            addCriterion("total_income not in", values, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_income between", value1, value2, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalIncomeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_income not between", value1, value2, "totalIncome");
            return (Criteria) this;
        }

        public Criteria andTotalAmountIsNull() {
            addCriterion("total_amount is null");
            return (Criteria) this;
        }

        public Criteria andTotalAmountIsNotNull() {
            addCriterion("total_amount is not null");
            return (Criteria) this;
        }

        public Criteria andTotalAmountEqualTo(BigDecimal value) {
            addCriterion("total_amount =", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountNotEqualTo(BigDecimal value) {
            addCriterion("total_amount <>", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountGreaterThan(BigDecimal value) {
            addCriterion("total_amount >", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_amount >=", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountLessThan(BigDecimal value) {
            addCriterion("total_amount <", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_amount <=", value, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountIn(List<BigDecimal> values) {
            addCriterion("total_amount in", values, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountNotIn(List<BigDecimal> values) {
            addCriterion("total_amount not in", values, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_amount between", value1, value2, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andTotalAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_amount not between", value1, value2, "totalAmount");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateIsNull() {
            addCriterion("return_on_investment_rate is null");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateIsNotNull() {
            addCriterion("return_on_investment_rate is not null");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateEqualTo(BigDecimal value) {
            addCriterion("return_on_investment_rate =", value, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateNotEqualTo(BigDecimal value) {
            addCriterion("return_on_investment_rate <>", value, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateGreaterThan(BigDecimal value) {
            addCriterion("return_on_investment_rate >", value, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("return_on_investment_rate >=", value, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateLessThan(BigDecimal value) {
            addCriterion("return_on_investment_rate <", value, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("return_on_investment_rate <=", value, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateIn(List<BigDecimal> values) {
            addCriterion("return_on_investment_rate in", values, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateNotIn(List<BigDecimal> values) {
            addCriterion("return_on_investment_rate not in", values, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("return_on_investment_rate between", value1, value2, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andReturnOnInvestmentRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("return_on_investment_rate not between", value1, value2, "returnOnInvestmentRate");
            return (Criteria) this;
        }

        public Criteria andDisposableInputIsNull() {
            addCriterion("disposable_input is null");
            return (Criteria) this;
        }

        public Criteria andDisposableInputIsNotNull() {
            addCriterion("disposable_input is not null");
            return (Criteria) this;
        }

        public Criteria andDisposableInputEqualTo(BigDecimal value) {
            addCriterion("disposable_input =", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputNotEqualTo(BigDecimal value) {
            addCriterion("disposable_input <>", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputGreaterThan(BigDecimal value) {
            addCriterion("disposable_input >", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("disposable_input >=", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputLessThan(BigDecimal value) {
            addCriterion("disposable_input <", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputLessThanOrEqualTo(BigDecimal value) {
            addCriterion("disposable_input <=", value, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputIn(List<BigDecimal> values) {
            addCriterion("disposable_input in", values, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputNotIn(List<BigDecimal> values) {
            addCriterion("disposable_input not in", values, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("disposable_input between", value1, value2, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andDisposableInputNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("disposable_input not between", value1, value2, "disposableInput");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentIsNull() {
            addCriterion("monthly_investment is null");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentIsNotNull() {
            addCriterion("monthly_investment is not null");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentEqualTo(BigDecimal value) {
            addCriterion("monthly_investment =", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentNotEqualTo(BigDecimal value) {
            addCriterion("monthly_investment <>", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentGreaterThan(BigDecimal value) {
            addCriterion("monthly_investment >", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("monthly_investment >=", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentLessThan(BigDecimal value) {
            addCriterion("monthly_investment <", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentLessThanOrEqualTo(BigDecimal value) {
            addCriterion("monthly_investment <=", value, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentIn(List<BigDecimal> values) {
            addCriterion("monthly_investment in", values, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentNotIn(List<BigDecimal> values) {
            addCriterion("monthly_investment not in", values, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("monthly_investment between", value1, value2, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andMonthlyInvestmentNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("monthly_investment not between", value1, value2, "monthlyInvestment");
            return (Criteria) this;
        }

        public Criteria andRegularYearIsNull() {
            addCriterion("regular_year is null");
            return (Criteria) this;
        }

        public Criteria andRegularYearIsNotNull() {
            addCriterion("regular_year is not null");
            return (Criteria) this;
        }

        public Criteria andRegularYearEqualTo(Integer value) {
            addCriterion("regular_year =", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearNotEqualTo(Integer value) {
            addCriterion("regular_year <>", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearGreaterThan(Integer value) {
            addCriterion("regular_year >", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearGreaterThanOrEqualTo(Integer value) {
            addCriterion("regular_year >=", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearLessThan(Integer value) {
            addCriterion("regular_year <", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearLessThanOrEqualTo(Integer value) {
            addCriterion("regular_year <=", value, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearIn(List<Integer> values) {
            addCriterion("regular_year in", values, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearNotIn(List<Integer> values) {
            addCriterion("regular_year not in", values, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearBetween(Integer value1, Integer value2) {
            addCriterion("regular_year between", value1, value2, "regularYear");
            return (Criteria) this;
        }

        public Criteria andRegularYearNotBetween(Integer value1, Integer value2) {
            addCriterion("regular_year not between", value1, value2, "regularYear");
            return (Criteria) this;
        }

        public Criteria andTargetAmountIsNull() {
            addCriterion("target_amount is null");
            return (Criteria) this;
        }

        public Criteria andTargetAmountIsNotNull() {
            addCriterion("target_amount is not null");
            return (Criteria) this;
        }

        public Criteria andTargetAmountEqualTo(BigDecimal value) {
            addCriterion("target_amount =", value, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountNotEqualTo(BigDecimal value) {
            addCriterion("target_amount <>", value, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountGreaterThan(BigDecimal value) {
            addCriterion("target_amount >", value, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("target_amount >=", value, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountLessThan(BigDecimal value) {
            addCriterion("target_amount <", value, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("target_amount <=", value, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountIn(List<BigDecimal> values) {
            addCriterion("target_amount in", values, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountNotIn(List<BigDecimal> values) {
            addCriterion("target_amount not in", values, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("target_amount between", value1, value2, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andTargetAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("target_amount not between", value1, value2, "targetAmount");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNull() {
            addCriterion("is_answer is null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNotNull() {
            addCriterion("is_answer is not null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerEqualTo(String value) {
            addCriterion("is_answer =", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotEqualTo(String value) {
            addCriterion("is_answer <>", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThan(String value) {
            addCriterion("is_answer >", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThanOrEqualTo(String value) {
            addCriterion("is_answer >=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThan(String value) {
            addCriterion("is_answer <", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThanOrEqualTo(String value) {
            addCriterion("is_answer <=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLike(String value) {
            addCriterion("is_answer like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotLike(String value) {
            addCriterion("is_answer not like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIn(List<String> values) {
            addCriterion("is_answer in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotIn(List<String> values) {
            addCriterion("is_answer not in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerBetween(String value1, String value2) {
            addCriterion("is_answer between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotBetween(String value1, String value2) {
            addCriterion("is_answer not between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIsNull() {
            addCriterion("analysis_teacher_score is null");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIsNotNull() {
            addCriterion("analysis_teacher_score is not null");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score =", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score <>", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreGreaterThan(BigDecimal value) {
            addCriterion("analysis_teacher_score >", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score >=", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreLessThan(BigDecimal value) {
            addCriterion("analysis_teacher_score <", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score <=", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIn(List<BigDecimal> values) {
            addCriterion("analysis_teacher_score in", values, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotIn(List<BigDecimal> values) {
            addCriterion("analysis_teacher_score not in", values, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("analysis_teacher_score between", value1, value2, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("analysis_teacher_score not between", value1, value2, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreIsNull() {
            addCriterion("case_teacher_score is null");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreIsNotNull() {
            addCriterion("case_teacher_score is not null");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreEqualTo(BigDecimal value) {
            addCriterion("case_teacher_score =", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreNotEqualTo(BigDecimal value) {
            addCriterion("case_teacher_score <>", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreGreaterThan(BigDecimal value) {
            addCriterion("case_teacher_score >", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("case_teacher_score >=", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreLessThan(BigDecimal value) {
            addCriterion("case_teacher_score <", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("case_teacher_score <=", value, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreIn(List<BigDecimal> values) {
            addCriterion("case_teacher_score in", values, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreNotIn(List<BigDecimal> values) {
            addCriterion("case_teacher_score not in", values, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("case_teacher_score between", value1, value2, "caseTeacherScore");
            return (Criteria) this;
        }

        public Criteria andCaseTeacherScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("case_teacher_score not between", value1, value2, "caseTeacherScore");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}