package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
/**
 * 实物黄金产品表
 *
 * @author xcj
 * realgold_product
 */
public class RealGoldProduct {
    @ApiModelProperty("实物黄金ID")
    private String realgoldProductId;

    @ApiModelProperty("交易日")
    private Date tradingDay;

    @ApiModelProperty("开盘价")
    private BigDecimal openingPrice;

    @ApiModelProperty("收盘价")
    private BigDecimal closingPrice;

    @ApiModelProperty("最高价")
    private BigDecimal highestPrice;

    @ApiModelProperty("最低价")
    private BigDecimal lowestPrice;

    @ApiModelProperty("涨跌幅")
    private BigDecimal applies;

    @ApiModelProperty("加权平均价")
    private BigDecimal averagePrice;

    @ApiModelProperty("近年年化收益率")
    private BigDecimal nearAnnualYield;

    public String getRealgoldProductId() {
        return realgoldProductId;
    }

    public void setRealgoldProductId(String realgoldProductId) {
        this.realgoldProductId = realgoldProductId == null ? null : realgoldProductId.trim();
    }

    public Date getTradingDay() {
        return tradingDay;
    }

    public void setTradingDay(Date tradingDay) {
        this.tradingDay = tradingDay;
    }

    public BigDecimal getOpeningPrice() {
        return openingPrice;
    }

    public void setOpeningPrice(BigDecimal openingPrice) {
        this.openingPrice = openingPrice;
    }

    public BigDecimal getClosingPrice() {
        return closingPrice;
    }

    public void setClosingPrice(BigDecimal closingPrice) {
        this.closingPrice = closingPrice;
    }

    public BigDecimal getHighestPrice() {
        return highestPrice;
    }

    public void setHighestPrice(BigDecimal highestPrice) {
        this.highestPrice = highestPrice;
    }

    public BigDecimal getLowestPrice() {
        return lowestPrice;
    }

    public void setLowestPrice(BigDecimal lowestPrice) {
        this.lowestPrice = lowestPrice;
    }

    public BigDecimal getApplies() {
        return applies;
    }

    public void setApplies(BigDecimal applies) {
        this.applies = applies;
    }

    public BigDecimal getAveragePrice() {
        return averagePrice;
    }

    public void setAveragePrice(BigDecimal averagePrice) {
        this.averagePrice = averagePrice;
    }

    public BigDecimal getNearAnnualYield() {
        return nearAnnualYield;
    }

    public void setNearAnnualYield(BigDecimal nearAnnualYield) {
        this.nearAnnualYield = nearAnnualYield;
    }
}