package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
/**
 * 学生理论考试表
 *
 * @author xcj
 * stu_theory_exam
 */
public class StuTheoryExam {
    @ApiModelProperty("理论考试ID")
    private String theoryExamId;

    @ApiModelProperty("用户ID")
    private String userId;

    @ApiModelProperty("考试时间")
    private Date examTime;

    @ApiModelProperty("考试用时")
    private Integer examDuration;

    @ApiModelProperty("得分")
    private BigDecimal score;

    @ApiModelProperty("是否答完 0未答完,1已答完")
    private Boolean answered;

    @ApiModelProperty("正确率")
    private BigDecimal accuracy;

    @ApiModelProperty("理论考试/理论知识/专业能力/公共基础/个人理财/风险管理/公司信贷/个人贷款")
    private String source;

    public String getTheoryExamId() {
        return theoryExamId;
    }

    public void setTheoryExamId(String theoryExamId) {
        this.theoryExamId = theoryExamId == null ? null : theoryExamId.trim();
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId == null ? null : userId.trim();
    }

    public Date getExamTime() {
        return examTime;
    }

    public void setExamTime(Date examTime) {
        this.examTime = examTime;
    }

    public Integer getExamDuration() {
        return examDuration;
    }

    public void setExamDuration(Integer examDuration) {
        this.examDuration = examDuration;
    }

    public BigDecimal getScore() {
        return score;
    }

    public void setScore(BigDecimal score) {
        this.score = score;
    }

    public Boolean getAnswered() {
        return answered;
    }

    public void setAnswered(Boolean answered) {
        this.answered = answered;
    }

    public BigDecimal getAccuracy() {
        return accuracy;
    }

    public void setAccuracy(BigDecimal accuracy) {
        this.accuracy = accuracy;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source == null ? null : source.trim();
    }
}