package com.sztzjy.money_management.entity;

import java.util.ArrayList;
import java.util.List;

public class UserStatisticsExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public UserStatisticsExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andUseridIsNull() {
            addCriterion("userid is null");
            return (Criteria) this;
        }

        public Criteria andUseridIsNotNull() {
            addCriterion("userid is not null");
            return (Criteria) this;
        }

        public Criteria andUseridEqualTo(String value) {
            addCriterion("userid =", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridNotEqualTo(String value) {
            addCriterion("userid <>", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridGreaterThan(String value) {
            addCriterion("userid >", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridGreaterThanOrEqualTo(String value) {
            addCriterion("userid >=", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridLessThan(String value) {
            addCriterion("userid <", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridLessThanOrEqualTo(String value) {
            addCriterion("userid <=", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridLike(String value) {
            addCriterion("userid like", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridNotLike(String value) {
            addCriterion("userid not like", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridIn(List<String> values) {
            addCriterion("userid in", values, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridNotIn(List<String> values) {
            addCriterion("userid not in", values, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridBetween(String value1, String value2) {
            addCriterion("userid between", value1, value2, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridNotBetween(String value1, String value2) {
            addCriterion("userid not between", value1, value2, "userid");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountIsNull() {
            addCriterion("high_net_client_have_count is null");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountIsNotNull() {
            addCriterion("high_net_client_have_count is not null");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountEqualTo(Integer value) {
            addCriterion("high_net_client_have_count =", value, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountNotEqualTo(Integer value) {
            addCriterion("high_net_client_have_count <>", value, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountGreaterThan(Integer value) {
            addCriterion("high_net_client_have_count >", value, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("high_net_client_have_count >=", value, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountLessThan(Integer value) {
            addCriterion("high_net_client_have_count <", value, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountLessThanOrEqualTo(Integer value) {
            addCriterion("high_net_client_have_count <=", value, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountIn(List<Integer> values) {
            addCriterion("high_net_client_have_count in", values, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountNotIn(List<Integer> values) {
            addCriterion("high_net_client_have_count not in", values, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountBetween(Integer value1, Integer value2) {
            addCriterion("high_net_client_have_count between", value1, value2, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientHaveCountNotBetween(Integer value1, Integer value2) {
            addCriterion("high_net_client_have_count not between", value1, value2, "highNetClientHaveCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountIsNull() {
            addCriterion("high_net_client_latent_count is null");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountIsNotNull() {
            addCriterion("high_net_client_latent_count is not null");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountEqualTo(Integer value) {
            addCriterion("high_net_client_latent_count =", value, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountNotEqualTo(Integer value) {
            addCriterion("high_net_client_latent_count <>", value, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountGreaterThan(Integer value) {
            addCriterion("high_net_client_latent_count >", value, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("high_net_client_latent_count >=", value, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountLessThan(Integer value) {
            addCriterion("high_net_client_latent_count <", value, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountLessThanOrEqualTo(Integer value) {
            addCriterion("high_net_client_latent_count <=", value, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountIn(List<Integer> values) {
            addCriterion("high_net_client_latent_count in", values, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountNotIn(List<Integer> values) {
            addCriterion("high_net_client_latent_count not in", values, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountBetween(Integer value1, Integer value2) {
            addCriterion("high_net_client_latent_count between", value1, value2, "highNetClientLatentCount");
            return (Criteria) this;
        }

        public Criteria andHighNetClientLatentCountNotBetween(Integer value1, Integer value2) {
            addCriterion("high_net_client_latent_count not between", value1, value2, "highNetClientLatentCount");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}