package com.sztzjy.money_management.service;

import com.github.pagehelper.PageInfo;
import com.sztzjy.money_management.entity.*;
import com.sztzjy.money_management.entity.dto.StuAuthTestDto;
import com.sztzjy.money_management.entity.dto.StuTheoryExamDetailDto;
import com.sztzjy.money_management.entity.dto.StuTheoryTestDto;
import com.sztzjy.money_management.util.ResultEntity;

import java.io.IOException;
import java.util.Date;
import java.util.List;

/**
 * @Author xcj
 * @Date 2024/8/22
 */
public interface TheoryTestService {
    PageInfo<StuTheoryExamWithBLOBs> getTheoryTestList(String userId, Integer index, Integer size);
    List<ObjectiveQuestionWithBLOBs> startTheoryTest(String userId, String schoolId,String source)throws IOException;
    List<StuTheoryExamDetailDto> getTheoryTestDetail(String theoryExamId, Integer index, Integer size) throws IOException;
    List<ObjectiveQuestionWithBLOBs> selectErrors(String userId,String schoolId);
    Boolean removeError(String userId, String objectiveQuestionId, Integer type);
    int endTheoryTest(StuTheoryTestDto theoryTestDto);
    Date getStartTime(String userId,String source);
    ResultEntity<PageInfo<StuAuthTestDto>> getAuthTestRecord(Integer index,Integer size,String userId,String source);
}
